using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.IO;
using System.Threading;

using CookComputing.XmlRpc;
using GameControler.XmlRpcInterface;

namespace GameControler
{
	/// <summary>
	/// Description rsume de Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.TabPage tabPage3;
		private System.Windows.Forms.TabPage tabPage4;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Label label22;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.Label label25;
		private System.Windows.Forms.Label label26;
		private System.Windows.Forms.Label label27;
		private System.Windows.Forms.Label label28;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label29;
		private System.Windows.Forms.Label label30;
		private System.Windows.Forms.Label label32;
		private System.Windows.Forms.Label label33;
		private System.Windows.Forms.Label label34;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label39;
		private System.Windows.Forms.Label label40;
		private System.Windows.Forms.Label label41;
		private System.Windows.Forms.Label label42;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.Label label47;
		private System.Windows.Forms.Label label48;
		private System.Windows.Forms.TextBox General_ServerComment;
		private System.Windows.Forms.TextBox General_ServerName;
		private System.Windows.Forms.CheckBox General_AllowP2PDownload;
		private System.Windows.Forms.CheckBox General_AllowP2PUpload;
		private System.Windows.Forms.TextBox GameInfo_Current_RoundPointsLimit;
		private System.Windows.Forms.CheckBox GameInfo_Next_TeamUseNewRules;
		private System.Windows.Forms.CheckBox GameInfo_Current_TeamUseNewRules;
		private System.Windows.Forms.CheckBox GameInfo_Current_RoundUseNewRules;
		private System.Windows.Forms.TextBox GameInfo_Current_NbChallenge;
		private System.Windows.Forms.TextBox GameInfo_Current_ChatTime;
		private System.Windows.Forms.TextBox GameInfo_Current_TimeAttackLimit;
		private System.Windows.Forms.TextBox GameInfo_Current_TeamPointsLimit;
		private System.Windows.Forms.TextBox GameInfo_Current_TeamMaxPoints;
		private System.Windows.Forms.TextBox GameInfo_Current_LapsNbLaps;
		private System.Windows.Forms.TextBox GameInfo_Current_LapsTimeLimit;
		private System.Windows.Forms.TextBox GameInfo_Next_ChatTime;
		private System.Windows.Forms.TextBox GameInfo_Next_NbChallenge;
		private System.Windows.Forms.TextBox GameInfo_Next_RoundPointsLimit;
		private System.Windows.Forms.TextBox GameInfo_Next_TimeAttackLimit;
		private System.Windows.Forms.TextBox GameInfo_Next_TeamPointsLimit;
		private System.Windows.Forms.TextBox GameInfo_Next_TeamMaxPoints;
		private System.Windows.Forms.TextBox GameInfo_Next_LapsNbLaps;
		private System.Windows.Forms.TextBox GameInfo_Next_LapsTimeLimit;
		private System.Windows.Forms.ComboBox GameInfo_Current_GameMode;
		private System.Windows.Forms.ComboBox GameInfo_Next_GameMode;
		private System.Windows.Forms.Label MapControl_ChallengeName;
		private System.Windows.Forms.Label MapControl_Environment;
		private System.Windows.Forms.Label MapControl_Filename;
		private System.Windows.Forms.Label MapControl_GoldTime;
		private System.Windows.Forms.ListView MapControl_Browser;
		private System.Windows.Forms.Button MapControl_Restart;
		private System.Windows.Forms.Button MapControl_NextMap;
		private System.Windows.Forms.Button MapControl_Add;
		private System.Windows.Forms.Button MapControl_Remove;
		private System.Windows.Forms.TextBox MapControl_EditFilename;
		private System.Windows.Forms.TextBox MapControl_EditPlaylistName;
		private System.Windows.Forms.Button MapControl_ImportPlaylist;
		private System.Windows.Forms.Button MapControl_ExportPlaylist;
		private System.Windows.Forms.Button MapControl_InsertPlaylist;
		private System.Windows.Forms.Button MapControl_AddPlaylist;
		private System.Windows.Forms.Label PlayerControl_Login;
		private System.Windows.Forms.Label PlayerControl_Nickname;
		private System.Windows.Forms.Label PlayerControl_Id;
		private System.Windows.Forms.Label PlayerControl_Ranking;
		private System.Windows.Forms.ListView PlayerControl_PlayerBrowser;
		private System.Windows.Forms.Button PlayerControl_Ban;
		private System.Windows.Forms.Button PlayerControl_Kick;
		private System.Windows.Forms.ListView PlayerControl_BanBrowser;
		private System.Windows.Forms.Button PlayerControl_Unban;
		private System.Windows.Forms.Button PlayerControl_ClearBan;
		private System.Windows.Forms.Button Control_Stop;
		private System.Windows.Forms.Button Control_Refresh;
		private System.Windows.Forms.Button Control_Shutdown;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.TextBox General_CurrentMaxPlayer;
		private System.Windows.Forms.Label label31;
		private System.Windows.Forms.Label label35;
		private System.Windows.Forms.TextBox General_NextMaxPlayer;
		private System.Windows.Forms.TabControl ServerTab;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.CheckBox GameInfo_Next_RoundUseNewRules;
		private System.Windows.Forms.Label label36;
		private System.Windows.Forms.Label label37;
		private System.Windows.Forms.Label Control_Status;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label Control_AuthStatus;
		private System.Windows.Forms.Button MapControl_PlaylistOK;
		private System.Windows.Forms.TabPage tabPage5;
		private System.Windows.Forms.GroupBox groupBox10;
		private System.Windows.Forms.GroupBox groupBox11;
		private System.Windows.Forms.Label label38;
		private System.Windows.Forms.Label label43;
		private System.Windows.Forms.Label label44;
		private System.Windows.Forms.Label label45;
		private System.Windows.Forms.Label label51;
		private System.Windows.Forms.Label label52;
		private System.Windows.Forms.Label label53;
		private System.Windows.Forms.Label label54;
		private System.Windows.Forms.Label ServerStats_Uptime;
		private System.Windows.Forms.Label ServerStats_MeanConnectionTime;
		private System.Windows.Forms.Label ServerStats_NbConnections;
		private System.Windows.Forms.Label ServerStats_MeanNbPlayer;
		private System.Windows.Forms.Label ServerStats_TotalSendingSize;
		private System.Windows.Forms.Label ServerStats_TotalReceivingSize;
		private System.Windows.Forms.Label ServerStats_RecNetRate;
		private System.Windows.Forms.Label ServerStats_SendNetRate;
		private System.Windows.Forms.Label label46;
		private System.Windows.Forms.Label label56;
		private System.Windows.Forms.Label label57;
		private System.Windows.Forms.Label label58;
		private System.Windows.Forms.Label label59;
		private System.Windows.Forms.Label ServerStats_Login;
		private System.Windows.Forms.Label ServerStats_IPAddress;
		private System.Windows.Forms.Label ServerStats_LastTransfertTime;
		private System.Windows.Forms.Label ServerStats_Delta;
		private System.Windows.Forms.Label ServerStats_PacketLoss;
		private System.Windows.Forms.ListView ServerStats_Browser;
		private System.Windows.Forms.GroupBox groupBox9;
		private System.Windows.Forms.ListView PlayerControl_BlackBrowser;
		private System.Windows.Forms.Button PlayerControl_CleanBlack;
		private System.Windows.Forms.Button PlayerControl_Unblack;
		private System.Windows.Forms.Button PlayerControl_Black;
		private System.Windows.Forms.Button Control_Start;
		private System.Windows.Forms.Label label50;
		private System.Windows.Forms.TabPage tabPage6;
		private System.Windows.Forms.Label label60;
		private System.Windows.Forms.Label label62;
		private System.Windows.Forms.Label label64;
		private System.Windows.Forms.Label label65;
		private System.Windows.Forms.Button Control_Launch;
		private System.Windows.Forms.Label Label_ServerName;
		private System.Windows.Forms.Button MapControl_BrowseChallenge;
		private System.Windows.Forms.TextBox Settings_GamePassword;
		private System.Windows.Forms.TextBox Settings_GameLogin;
		private System.Windows.Forms.TextBox Settings_Password;
		private System.Windows.Forms.TextBox Settings_Login;
		private System.Windows.Forms.CheckBox Settings_IsInternetServer;
		private System.Windows.Forms.Label Control_AppStatus;
		private System.Windows.Forms.Button General_Edit;
		private System.Windows.Forms.Button GameInfo_Edit;		
		private System.Windows.Forms.Button Settings_Edit;

		private static System.Windows.Forms.Timer ServerTimer = new System.Windows.Forms.Timer();
		private System.Windows.Forms.TextBox General_PlayerPassword;
		private System.Windows.Forms.Label Label_PlayerPassword;
		private System.Windows.Forms.TextBox General_SpectatorPassword;
		private System.Windows.Forms.Label Label_SpectatorPassword;
		private System.Windows.Forms.Button Control_Load;
		private System.Windows.Forms.Button Control_Save;
		private System.Windows.Forms.Label label49;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox General_CurrentMaxSpectator;
		private System.Windows.Forms.TextBox General_NextMaxSpectator;
		private System.Windows.Forms.TextBox MapControl_EditCurrentChallenge;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.Label MapControl_Mood;
		private static GameboxRemote Proxy;
		
		public Form1()
		{
			InitializeComponent();
			InitializeServerPanels();
			InitializeLocalization();

			// defaults
			Settings_Login.Text = "SuperAdmin";
			Settings_Password.Text = "SuperAdmin";
			Settings_IsInternetServer.Checked = false;

			Mutex mu = new Mutex(true, "RequestMutex");
			mu.ReleaseMutex();
			Proxy = (GameboxRemote)XmlRpcProxyGen.Create(typeof(GameboxRemote), mu);
			
			// set the server url.  (optional)
			((XmlRpcClientProtocol)Proxy).Url = "gbx://127.0.0.1:5000";
			
			/*Control_Timer(this,null);
			ServerTimer.Tick += new EventHandler(Control_Timer);
			ServerTimer.Interval = 10000; // ms
			ServerTimer.Start();*/
			
			RefreshCurrentTab();
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

			
		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.ServerTab = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.General_NextMaxPlayer = new System.Windows.Forms.TextBox();
			this.label35 = new System.Windows.Forms.Label();
			this.label31 = new System.Windows.Forms.Label();
			this.General_PlayerPassword = new System.Windows.Forms.TextBox();
			this.General_CurrentMaxPlayer = new System.Windows.Forms.TextBox();
			this.General_ServerComment = new System.Windows.Forms.TextBox();
			this.General_ServerName = new System.Windows.Forms.TextBox();
			this.General_AllowP2PDownload = new System.Windows.Forms.CheckBox();
			this.General_AllowP2PUpload = new System.Windows.Forms.CheckBox();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.Label_PlayerPassword = new System.Windows.Forms.Label();
			this.Label_ServerName = new System.Windows.Forms.Label();
			this.General_Edit = new System.Windows.Forms.Button();
			this.General_SpectatorPassword = new System.Windows.Forms.TextBox();
			this.Label_SpectatorPassword = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.General_CurrentMaxSpectator = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.General_NextMaxSpectator = new System.Windows.Forms.TextBox();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.GameInfo_Edit = new System.Windows.Forms.Button();
			this.GameInfo_Next_GameMode = new System.Windows.Forms.ComboBox();
			this.GameInfo_Current_GameMode = new System.Windows.Forms.ComboBox();
			this.GameInfo_Next_LapsTimeLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_LapsNbLaps = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_TeamMaxPoints = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_TeamPointsLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_TimeAttackLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_RoundPointsLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_NbChallenge = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_ChatTime = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_LapsTimeLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_LapsNbLaps = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_TeamMaxPoints = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_TeamPointsLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_TimeAttackLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_ChatTime = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_NbChallenge = new System.Windows.Forms.TextBox();
			this.GameInfo_Current_RoundPointsLimit = new System.Windows.Forms.TextBox();
			this.GameInfo_Next_TeamUseNewRules = new System.Windows.Forms.CheckBox();
			this.GameInfo_Next_RoundUseNewRules = new System.Windows.Forms.CheckBox();
			this.GameInfo_Current_TeamUseNewRules = new System.Windows.Forms.CheckBox();
			this.GameInfo_Current_RoundUseNewRules = new System.Windows.Forms.CheckBox();
			this.label23 = new System.Windows.Forms.Label();
			this.label22 = new System.Windows.Forms.Label();
			this.label21 = new System.Windows.Forms.Label();
			this.label20 = new System.Windows.Forms.Label();
			this.label19 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label24 = new System.Windows.Forms.Label();
			this.label25 = new System.Windows.Forms.Label();
			this.label26 = new System.Windows.Forms.Label();
			this.label27 = new System.Windows.Forms.Label();
			this.label28 = new System.Windows.Forms.Label();
			this.tabPage3 = new System.Windows.Forms.TabPage();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.MapControl_PlaylistOK = new System.Windows.Forms.Button();
			this.MapControl_AddPlaylist = new System.Windows.Forms.Button();
			this.MapControl_InsertPlaylist = new System.Windows.Forms.Button();
			this.MapControl_ExportPlaylist = new System.Windows.Forms.Button();
			this.MapControl_ImportPlaylist = new System.Windows.Forms.Button();
			this.MapControl_EditPlaylistName = new System.Windows.Forms.TextBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.MapControl_EditFilename = new System.Windows.Forms.TextBox();
			this.MapControl_Remove = new System.Windows.Forms.Button();
			this.MapControl_Add = new System.Windows.Forms.Button();
			this.MapControl_NextMap = new System.Windows.Forms.Button();
			this.MapControl_Restart = new System.Windows.Forms.Button();
			this.MapControl_Browser = new System.Windows.Forms.ListView();
			this.MapControl_BrowseChallenge = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.MapControl_GoldTime = new System.Windows.Forms.Label();
			this.MapControl_Filename = new System.Windows.Forms.Label();
			this.MapControl_Mood = new System.Windows.Forms.Label();
			this.MapControl_ChallengeName = new System.Windows.Forms.Label();
			this.label33 = new System.Windows.Forms.Label();
			this.label30 = new System.Windows.Forms.Label();
			this.label29 = new System.Windows.Forms.Label();
			this.label32 = new System.Windows.Forms.Label();
			this.MapControl_Environment = new System.Windows.Forms.Label();
			this.label34 = new System.Windows.Forms.Label();
			this.tabPage4 = new System.Windows.Forms.TabPage();
			this.groupBox9 = new System.Windows.Forms.GroupBox();
			this.PlayerControl_BlackBrowser = new System.Windows.Forms.ListView();
			this.PlayerControl_CleanBlack = new System.Windows.Forms.Button();
			this.PlayerControl_Unblack = new System.Windows.Forms.Button();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.PlayerControl_Black = new System.Windows.Forms.Button();
			this.PlayerControl_Kick = new System.Windows.Forms.Button();
			this.PlayerControl_Ban = new System.Windows.Forms.Button();
			this.PlayerControl_PlayerBrowser = new System.Windows.Forms.ListView();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.PlayerControl_Ranking = new System.Windows.Forms.Label();
			this.PlayerControl_Id = new System.Windows.Forms.Label();
			this.PlayerControl_Nickname = new System.Windows.Forms.Label();
			this.PlayerControl_Login = new System.Windows.Forms.Label();
			this.label42 = new System.Windows.Forms.Label();
			this.label41 = new System.Windows.Forms.Label();
			this.label40 = new System.Windows.Forms.Label();
			this.label39 = new System.Windows.Forms.Label();
			this.groupBox7 = new System.Windows.Forms.GroupBox();
			this.PlayerControl_ClearBan = new System.Windows.Forms.Button();
			this.PlayerControl_BanBrowser = new System.Windows.Forms.ListView();
			this.PlayerControl_Unban = new System.Windows.Forms.Button();
			this.tabPage5 = new System.Windows.Forms.TabPage();
			this.groupBox11 = new System.Windows.Forms.GroupBox();
			this.ServerStats_PacketLoss = new System.Windows.Forms.Label();
			this.ServerStats_Delta = new System.Windows.Forms.Label();
			this.ServerStats_LastTransfertTime = new System.Windows.Forms.Label();
			this.ServerStats_IPAddress = new System.Windows.Forms.Label();
			this.ServerStats_Login = new System.Windows.Forms.Label();
			this.label59 = new System.Windows.Forms.Label();
			this.label58 = new System.Windows.Forms.Label();
			this.label57 = new System.Windows.Forms.Label();
			this.label56 = new System.Windows.Forms.Label();
			this.label46 = new System.Windows.Forms.Label();
			this.ServerStats_Browser = new System.Windows.Forms.ListView();
			this.groupBox10 = new System.Windows.Forms.GroupBox();
			this.ServerStats_SendNetRate = new System.Windows.Forms.Label();
			this.ServerStats_RecNetRate = new System.Windows.Forms.Label();
			this.ServerStats_TotalReceivingSize = new System.Windows.Forms.Label();
			this.ServerStats_TotalSendingSize = new System.Windows.Forms.Label();
			this.ServerStats_MeanNbPlayer = new System.Windows.Forms.Label();
			this.ServerStats_NbConnections = new System.Windows.Forms.Label();
			this.ServerStats_MeanConnectionTime = new System.Windows.Forms.Label();
			this.ServerStats_Uptime = new System.Windows.Forms.Label();
			this.label54 = new System.Windows.Forms.Label();
			this.label53 = new System.Windows.Forms.Label();
			this.label52 = new System.Windows.Forms.Label();
			this.label51 = new System.Windows.Forms.Label();
			this.label45 = new System.Windows.Forms.Label();
			this.label44 = new System.Windows.Forms.Label();
			this.label43 = new System.Windows.Forms.Label();
			this.label38 = new System.Windows.Forms.Label();
			this.tabPage6 = new System.Windows.Forms.TabPage();
			this.Settings_Edit = new System.Windows.Forms.Button();
			this.Settings_GamePassword = new System.Windows.Forms.TextBox();
			this.Settings_GameLogin = new System.Windows.Forms.TextBox();
			this.label65 = new System.Windows.Forms.Label();
			this.label64 = new System.Windows.Forms.Label();
			this.label62 = new System.Windows.Forms.Label();
			this.label60 = new System.Windows.Forms.Label();
			this.Settings_Password = new System.Windows.Forms.TextBox();
			this.Settings_Login = new System.Windows.Forms.TextBox();
			this.label37 = new System.Windows.Forms.Label();
			this.label36 = new System.Windows.Forms.Label();
			this.Settings_IsInternetServer = new System.Windows.Forms.CheckBox();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.Control_Launch = new System.Windows.Forms.Button();
			this.Control_AppStatus = new System.Windows.Forms.Label();
			this.label50 = new System.Windows.Forms.Label();
			this.Control_AuthStatus = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label49 = new System.Windows.Forms.Label();
			this.label48 = new System.Windows.Forms.Label();
			this.label47 = new System.Windows.Forms.Label();
			this.Control_Load = new System.Windows.Forms.Button();
			this.Control_Shutdown = new System.Windows.Forms.Button();
			this.Control_Save = new System.Windows.Forms.Button();
			this.Control_Refresh = new System.Windows.Forms.Button();
			this.Control_Stop = new System.Windows.Forms.Button();
			this.Control_Start = new System.Windows.Forms.Button();
			this.Control_Status = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.MapControl_EditCurrentChallenge = new System.Windows.Forms.TextBox();
			this.groupBox8 = new System.Windows.Forms.GroupBox();
			this.ServerTab.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.tabPage3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.tabPage4.SuspendLayout();
			this.groupBox9.SuspendLayout();
			this.groupBox6.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.groupBox7.SuspendLayout();
			this.tabPage5.SuspendLayout();
			this.groupBox11.SuspendLayout();
			this.groupBox10.SuspendLayout();
			this.tabPage6.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox8.SuspendLayout();
			this.SuspendLayout();
			// 
			// ServerTab
			// 
			this.ServerTab.Appearance = System.Windows.Forms.TabAppearance.FlatButtons;
			this.ServerTab.Controls.Add(this.tabPage1);
			this.ServerTab.Controls.Add(this.tabPage2);
			this.ServerTab.Controls.Add(this.tabPage3);
			this.ServerTab.Controls.Add(this.tabPage4);
			this.ServerTab.Controls.Add(this.tabPage5);
			this.ServerTab.Controls.Add(this.tabPage6);
			this.ServerTab.Location = new System.Drawing.Point(192, 152);
			this.ServerTab.Name = "ServerTab";
			this.ServerTab.SelectedIndex = 0;
			this.ServerTab.Size = new System.Drawing.Size(600, 424);
			this.ServerTab.TabIndex = 0;
			this.ServerTab.SelectedIndexChanged += new System.EventHandler(this.ServerTab_SelectedIndexChanged);
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.General_NextMaxPlayer);
			this.tabPage1.Controls.Add(this.label35);
			this.tabPage1.Controls.Add(this.label31);
			this.tabPage1.Controls.Add(this.General_PlayerPassword);
			this.tabPage1.Controls.Add(this.General_CurrentMaxPlayer);
			this.tabPage1.Controls.Add(this.General_ServerComment);
			this.tabPage1.Controls.Add(this.General_ServerName);
			this.tabPage1.Controls.Add(this.General_AllowP2PDownload);
			this.tabPage1.Controls.Add(this.General_AllowP2PUpload);
			this.tabPage1.Controls.Add(this.label9);
			this.tabPage1.Controls.Add(this.label8);
			this.tabPage1.Controls.Add(this.label6);
			this.tabPage1.Controls.Add(this.label5);
			this.tabPage1.Controls.Add(this.Label_PlayerPassword);
			this.tabPage1.Controls.Add(this.Label_ServerName);
			this.tabPage1.Controls.Add(this.General_Edit);
			this.tabPage1.Controls.Add(this.General_SpectatorPassword);
			this.tabPage1.Controls.Add(this.Label_SpectatorPassword);
			this.tabPage1.Controls.Add(this.label3);
			this.tabPage1.Controls.Add(this.label4);
			this.tabPage1.Controls.Add(this.General_CurrentMaxSpectator);
			this.tabPage1.Controls.Add(this.label7);
			this.tabPage1.Controls.Add(this.General_NextMaxSpectator);
			this.tabPage1.Location = new System.Drawing.Point(4, 25);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(592, 395);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Tag = "General";
			this.tabPage1.Text = "General";
			// 
			// General_NextMaxPlayer
			// 
			this.General_NextMaxPlayer.Location = new System.Drawing.Point(336, 104);
			this.General_NextMaxPlayer.Name = "General_NextMaxPlayer";
			this.General_NextMaxPlayer.Size = new System.Drawing.Size(48, 20);
			this.General_NextMaxPlayer.TabIndex = 4;
			this.General_NextMaxPlayer.Text = "";
			this.General_NextMaxPlayer.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// label35
			// 
			this.label35.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label35.Location = new System.Drawing.Point(280, 104);
			this.label35.Name = "label35";
			this.label35.Size = new System.Drawing.Size(40, 16);
			this.label35.TabIndex = 16;
			this.label35.Tag = "Next :";
			this.label35.Text = "Next :";
			this.label35.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// label31
			// 
			this.label31.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label31.Location = new System.Drawing.Point(176, 104);
			this.label31.Name = "label31";
			this.label31.Size = new System.Drawing.Size(48, 16);
			this.label31.TabIndex = 15;
			this.label31.Tag = "Current :";
			this.label31.Text = "Current :";
			this.label31.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// General_PlayerPassword
			// 
			this.General_PlayerPassword.Location = new System.Drawing.Point(168, 56);
			this.General_PlayerPassword.Name = "General_PlayerPassword";
			this.General_PlayerPassword.Size = new System.Drawing.Size(216, 20);
			this.General_PlayerPassword.TabIndex = 2;
			this.General_PlayerPassword.Text = "";
			// 
			// General_CurrentMaxPlayer
			// 
			this.General_CurrentMaxPlayer.Location = new System.Drawing.Point(224, 104);
			this.General_CurrentMaxPlayer.Name = "General_CurrentMaxPlayer";
			this.General_CurrentMaxPlayer.Size = new System.Drawing.Size(48, 20);
			this.General_CurrentMaxPlayer.TabIndex = 3;
			this.General_CurrentMaxPlayer.Text = "";
			this.General_CurrentMaxPlayer.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// General_ServerComment
			// 
			this.General_ServerComment.Location = new System.Drawing.Point(168, 152);
			this.General_ServerComment.Multiline = true;
			this.General_ServerComment.Name = "General_ServerComment";
			this.General_ServerComment.Size = new System.Drawing.Size(216, 112);
			this.General_ServerComment.TabIndex = 5;
			this.General_ServerComment.Text = "";
			// 
			// General_ServerName
			// 
			this.General_ServerName.Location = new System.Drawing.Point(168, 32);
			this.General_ServerName.Name = "General_ServerName";
			this.General_ServerName.Size = new System.Drawing.Size(216, 20);
			this.General_ServerName.TabIndex = 1;
			this.General_ServerName.Text = "";
			// 
			// General_AllowP2PDownload
			// 
			this.General_AllowP2PDownload.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.General_AllowP2PDownload.Location = new System.Drawing.Point(168, 272);
			this.General_AllowP2PDownload.Name = "General_AllowP2PDownload";
			this.General_AllowP2PDownload.Size = new System.Drawing.Size(144, 23);
			this.General_AllowP2PDownload.TabIndex = 7;
			// 
			// General_AllowP2PUpload
			// 
			this.General_AllowP2PUpload.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.General_AllowP2PUpload.Location = new System.Drawing.Point(168, 296);
			this.General_AllowP2PUpload.Name = "General_AllowP2PUpload";
			this.General_AllowP2PUpload.Size = new System.Drawing.Size(144, 23);
			this.General_AllowP2PUpload.TabIndex = 8;
			// 
			// label9
			// 
			this.label9.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label9.Location = new System.Drawing.Point(8, 104);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(144, 23);
			this.label9.TabIndex = 6;
			this.label9.Tag = "Max Player :";
			this.label9.Text = "Max Player :";
			this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label8
			// 
			this.label8.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label8.Location = new System.Drawing.Point(8, 152);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(144, 23);
			this.label8.TabIndex = 5;
			this.label8.Tag = "Server Comment :";
			this.label8.Text = "Server Comment :";
			this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label6
			// 
			this.label6.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label6.Location = new System.Drawing.Point(8, 272);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(144, 23);
			this.label6.TabIndex = 3;
			this.label6.Tag = "Allow P2P Download :";
			this.label6.Text = "Allow P2P Download :";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label5
			// 
			this.label5.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label5.Location = new System.Drawing.Point(8, 296);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(144, 23);
			this.label5.TabIndex = 2;
			this.label5.Tag = "Allow P2P Upload :";
			this.label5.Text = "Allow P2P Upload :";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label_PlayerPassword
			// 
			this.Label_PlayerPassword.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Label_PlayerPassword.Location = new System.Drawing.Point(8, 56);
			this.Label_PlayerPassword.Name = "Label_PlayerPassword";
			this.Label_PlayerPassword.Size = new System.Drawing.Size(144, 23);
			this.Label_PlayerPassword.TabIndex = 1;
			this.Label_PlayerPassword.Tag = "Player Password :";
			this.Label_PlayerPassword.Text = "Player Password :";
			this.Label_PlayerPassword.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label_ServerName
			// 
			this.Label_ServerName.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Label_ServerName.Location = new System.Drawing.Point(8, 32);
			this.Label_ServerName.Name = "Label_ServerName";
			this.Label_ServerName.Size = new System.Drawing.Size(144, 23);
			this.Label_ServerName.TabIndex = 0;
			this.Label_ServerName.Tag = "Server Name :";
			this.Label_ServerName.Text = "Server Name :";
			this.Label_ServerName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// General_Edit
			// 
			this.General_Edit.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.General_Edit.Location = new System.Drawing.Point(496, 344);
			this.General_Edit.Name = "General_Edit";
			this.General_Edit.Size = new System.Drawing.Size(64, 24);
			this.General_Edit.TabIndex = 7;
			this.General_Edit.Tag = "Edit";
			this.General_Edit.Text = "Edit";
			this.General_Edit.Click += new System.EventHandler(this.General_Edit_Click);
			// 
			// General_SpectatorPassword
			// 
			this.General_SpectatorPassword.Location = new System.Drawing.Point(168, 80);
			this.General_SpectatorPassword.Name = "General_SpectatorPassword";
			this.General_SpectatorPassword.Size = new System.Drawing.Size(216, 20);
			this.General_SpectatorPassword.TabIndex = 2;
			this.General_SpectatorPassword.Text = "";
			// 
			// Label_SpectatorPassword
			// 
			this.Label_SpectatorPassword.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Label_SpectatorPassword.Location = new System.Drawing.Point(8, 80);
			this.Label_SpectatorPassword.Name = "Label_SpectatorPassword";
			this.Label_SpectatorPassword.Size = new System.Drawing.Size(144, 23);
			this.Label_SpectatorPassword.TabIndex = 1;
			this.Label_SpectatorPassword.Tag = "Spectator Password :";
			this.Label_SpectatorPassword.Text = "Spectator Password :";
			this.Label_SpectatorPassword.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label3
			// 
			this.label3.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label3.Location = new System.Drawing.Point(280, 128);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 16;
			this.label3.Tag = "Next :";
			this.label3.Text = "Next :";
			this.label3.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// label4
			// 
			this.label4.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label4.Location = new System.Drawing.Point(176, 128);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(48, 16);
			this.label4.TabIndex = 15;
			this.label4.Tag = "Current :";
			this.label4.Text = "Current :";
			this.label4.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// General_CurrentMaxSpectator
			// 
			this.General_CurrentMaxSpectator.Location = new System.Drawing.Point(224, 128);
			this.General_CurrentMaxSpectator.Name = "General_CurrentMaxSpectator";
			this.General_CurrentMaxSpectator.Size = new System.Drawing.Size(48, 20);
			this.General_CurrentMaxSpectator.TabIndex = 3;
			this.General_CurrentMaxSpectator.Text = "";
			this.General_CurrentMaxSpectator.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// label7
			// 
			this.label7.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label7.Location = new System.Drawing.Point(8, 128);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(144, 23);
			this.label7.TabIndex = 6;
			this.label7.Tag = "Max Spectators :";
			this.label7.Text = "Max Spectators :";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// General_NextMaxSpectator
			// 
			this.General_NextMaxSpectator.Location = new System.Drawing.Point(336, 128);
			this.General_NextMaxSpectator.Name = "General_NextMaxSpectator";
			this.General_NextMaxSpectator.Size = new System.Drawing.Size(48, 20);
			this.General_NextMaxSpectator.TabIndex = 4;
			this.General_NextMaxSpectator.Text = "";
			this.General_NextMaxSpectator.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.GameInfo_Edit);
			this.tabPage2.Controls.Add(this.GameInfo_Next_GameMode);
			this.tabPage2.Controls.Add(this.GameInfo_Current_GameMode);
			this.tabPage2.Controls.Add(this.GameInfo_Next_LapsTimeLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Next_LapsNbLaps);
			this.tabPage2.Controls.Add(this.GameInfo_Next_TeamMaxPoints);
			this.tabPage2.Controls.Add(this.GameInfo_Next_TeamPointsLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Next_TimeAttackLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Next_RoundPointsLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Next_NbChallenge);
			this.tabPage2.Controls.Add(this.GameInfo_Next_ChatTime);
			this.tabPage2.Controls.Add(this.GameInfo_Current_LapsTimeLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Current_LapsNbLaps);
			this.tabPage2.Controls.Add(this.GameInfo_Current_TeamMaxPoints);
			this.tabPage2.Controls.Add(this.GameInfo_Current_TeamPointsLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Current_TimeAttackLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Current_ChatTime);
			this.tabPage2.Controls.Add(this.GameInfo_Current_NbChallenge);
			this.tabPage2.Controls.Add(this.GameInfo_Current_RoundPointsLimit);
			this.tabPage2.Controls.Add(this.GameInfo_Next_TeamUseNewRules);
			this.tabPage2.Controls.Add(this.GameInfo_Next_RoundUseNewRules);
			this.tabPage2.Controls.Add(this.GameInfo_Current_TeamUseNewRules);
			this.tabPage2.Controls.Add(this.GameInfo_Current_RoundUseNewRules);
			this.tabPage2.Controls.Add(this.label23);
			this.tabPage2.Controls.Add(this.label22);
			this.tabPage2.Controls.Add(this.label21);
			this.tabPage2.Controls.Add(this.label20);
			this.tabPage2.Controls.Add(this.label19);
			this.tabPage2.Controls.Add(this.label18);
			this.tabPage2.Controls.Add(this.label17);
			this.tabPage2.Controls.Add(this.label16);
			this.tabPage2.Controls.Add(this.label15);
			this.tabPage2.Controls.Add(this.label14);
			this.tabPage2.Controls.Add(this.label13);
			this.tabPage2.Controls.Add(this.label12);
			this.tabPage2.Controls.Add(this.label11);
			this.tabPage2.Controls.Add(this.label10);
			this.tabPage2.Controls.Add(this.label24);
			this.tabPage2.Controls.Add(this.label25);
			this.tabPage2.Controls.Add(this.label26);
			this.tabPage2.Controls.Add(this.label27);
			this.tabPage2.Controls.Add(this.label28);
			this.tabPage2.Location = new System.Drawing.Point(4, 25);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(592, 395);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Tag = "Game Info";
			this.tabPage2.Text = "Game Info";
			// 
			// GameInfo_Edit
			// 
			this.GameInfo_Edit.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GameInfo_Edit.Location = new System.Drawing.Point(496, 344);
			this.GameInfo_Edit.Name = "GameInfo_Edit";
			this.GameInfo_Edit.Size = new System.Drawing.Size(64, 24);
			this.GameInfo_Edit.TabIndex = 36;
			this.GameInfo_Edit.Tag = "Edit";
			this.GameInfo_Edit.Text = "Edit";
			this.GameInfo_Edit.Click += new System.EventHandler(this.GameInfo_Edit_Click);
			// 
			// GameInfo_Next_GameMode
			// 
			this.GameInfo_Next_GameMode.Items.AddRange(new object[] {
																		"Rounds",
																		"TimeAttack",
																		"Team",
																		"Laps",
																		"Stunts"});
			this.GameInfo_Next_GameMode.Location = new System.Drawing.Point(352, 32);
			this.GameInfo_Next_GameMode.Name = "GameInfo_Next_GameMode";
			this.GameInfo_Next_GameMode.Size = new System.Drawing.Size(144, 21);
			this.GameInfo_Next_GameMode.TabIndex = 1;
			// 
			// GameInfo_Current_GameMode
			// 
			this.GameInfo_Current_GameMode.Items.AddRange(new object[] {
																		   "Rounds",
																		   "TimeAttack",
																		   "Team",
																		   "Laps",
																		   "Stunts"});
			this.GameInfo_Current_GameMode.Location = new System.Drawing.Point(168, 32);
			this.GameInfo_Current_GameMode.Name = "GameInfo_Current_GameMode";
			this.GameInfo_Current_GameMode.Size = new System.Drawing.Size(144, 21);
			this.GameInfo_Current_GameMode.TabIndex = 34;
			// 
			// GameInfo_Next_LapsTimeLimit
			// 
			this.GameInfo_Next_LapsTimeLimit.Location = new System.Drawing.Point(352, 272);
			this.GameInfo_Next_LapsTimeLimit.Name = "GameInfo_Next_LapsTimeLimit";
			this.GameInfo_Next_LapsTimeLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_LapsTimeLimit.TabIndex = 11;
			this.GameInfo_Next_LapsTimeLimit.Text = "";
			// 
			// GameInfo_Next_LapsNbLaps
			// 
			this.GameInfo_Next_LapsNbLaps.Location = new System.Drawing.Point(352, 248);
			this.GameInfo_Next_LapsNbLaps.Name = "GameInfo_Next_LapsNbLaps";
			this.GameInfo_Next_LapsNbLaps.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_LapsNbLaps.TabIndex = 10;
			this.GameInfo_Next_LapsNbLaps.Text = "";
			// 
			// GameInfo_Next_TeamMaxPoints
			// 
			this.GameInfo_Next_TeamMaxPoints.Location = new System.Drawing.Point(352, 200);
			this.GameInfo_Next_TeamMaxPoints.Name = "GameInfo_Next_TeamMaxPoints";
			this.GameInfo_Next_TeamMaxPoints.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_TeamMaxPoints.TabIndex = 8;
			this.GameInfo_Next_TeamMaxPoints.Text = "";
			// 
			// GameInfo_Next_TeamPointsLimit
			// 
			this.GameInfo_Next_TeamPointsLimit.Location = new System.Drawing.Point(352, 176);
			this.GameInfo_Next_TeamPointsLimit.Name = "GameInfo_Next_TeamPointsLimit";
			this.GameInfo_Next_TeamPointsLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_TeamPointsLimit.TabIndex = 7;
			this.GameInfo_Next_TeamPointsLimit.Text = "";
			// 
			// GameInfo_Next_TimeAttackLimit
			// 
			this.GameInfo_Next_TimeAttackLimit.Location = new System.Drawing.Point(352, 152);
			this.GameInfo_Next_TimeAttackLimit.Name = "GameInfo_Next_TimeAttackLimit";
			this.GameInfo_Next_TimeAttackLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_TimeAttackLimit.TabIndex = 6;
			this.GameInfo_Next_TimeAttackLimit.Text = "";
			// 
			// GameInfo_Next_RoundPointsLimit
			// 
			this.GameInfo_Next_RoundPointsLimit.Location = new System.Drawing.Point(352, 104);
			this.GameInfo_Next_RoundPointsLimit.Name = "GameInfo_Next_RoundPointsLimit";
			this.GameInfo_Next_RoundPointsLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_RoundPointsLimit.TabIndex = 4;
			this.GameInfo_Next_RoundPointsLimit.Text = "";
			// 
			// GameInfo_Next_NbChallenge
			// 
			this.GameInfo_Next_NbChallenge.Location = new System.Drawing.Point(352, 80);
			this.GameInfo_Next_NbChallenge.Name = "GameInfo_Next_NbChallenge";
			this.GameInfo_Next_NbChallenge.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_NbChallenge.TabIndex = 3;
			this.GameInfo_Next_NbChallenge.Text = "";
			// 
			// GameInfo_Next_ChatTime
			// 
			this.GameInfo_Next_ChatTime.Location = new System.Drawing.Point(352, 56);
			this.GameInfo_Next_ChatTime.Name = "GameInfo_Next_ChatTime";
			this.GameInfo_Next_ChatTime.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Next_ChatTime.TabIndex = 2;
			this.GameInfo_Next_ChatTime.Text = "";
			// 
			// GameInfo_Current_LapsTimeLimit
			// 
			this.GameInfo_Current_LapsTimeLimit.Location = new System.Drawing.Point(168, 272);
			this.GameInfo_Current_LapsTimeLimit.Name = "GameInfo_Current_LapsTimeLimit";
			this.GameInfo_Current_LapsTimeLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_LapsTimeLimit.TabIndex = 25;
			this.GameInfo_Current_LapsTimeLimit.Text = "";
			// 
			// GameInfo_Current_LapsNbLaps
			// 
			this.GameInfo_Current_LapsNbLaps.Location = new System.Drawing.Point(168, 248);
			this.GameInfo_Current_LapsNbLaps.Name = "GameInfo_Current_LapsNbLaps";
			this.GameInfo_Current_LapsNbLaps.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_LapsNbLaps.TabIndex = 24;
			this.GameInfo_Current_LapsNbLaps.Text = "";
			// 
			// GameInfo_Current_TeamMaxPoints
			// 
			this.GameInfo_Current_TeamMaxPoints.Location = new System.Drawing.Point(168, 200);
			this.GameInfo_Current_TeamMaxPoints.Name = "GameInfo_Current_TeamMaxPoints";
			this.GameInfo_Current_TeamMaxPoints.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_TeamMaxPoints.TabIndex = 23;
			this.GameInfo_Current_TeamMaxPoints.Text = "";
			// 
			// GameInfo_Current_TeamPointsLimit
			// 
			this.GameInfo_Current_TeamPointsLimit.Location = new System.Drawing.Point(168, 176);
			this.GameInfo_Current_TeamPointsLimit.Name = "GameInfo_Current_TeamPointsLimit";
			this.GameInfo_Current_TeamPointsLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_TeamPointsLimit.TabIndex = 22;
			this.GameInfo_Current_TeamPointsLimit.Text = "";
			// 
			// GameInfo_Current_TimeAttackLimit
			// 
			this.GameInfo_Current_TimeAttackLimit.Location = new System.Drawing.Point(168, 152);
			this.GameInfo_Current_TimeAttackLimit.Name = "GameInfo_Current_TimeAttackLimit";
			this.GameInfo_Current_TimeAttackLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_TimeAttackLimit.TabIndex = 21;
			this.GameInfo_Current_TimeAttackLimit.Text = "";
			// 
			// GameInfo_Current_ChatTime
			// 
			this.GameInfo_Current_ChatTime.Location = new System.Drawing.Point(168, 56);
			this.GameInfo_Current_ChatTime.Name = "GameInfo_Current_ChatTime";
			this.GameInfo_Current_ChatTime.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_ChatTime.TabIndex = 20;
			this.GameInfo_Current_ChatTime.Text = "";
			// 
			// GameInfo_Current_NbChallenge
			// 
			this.GameInfo_Current_NbChallenge.Location = new System.Drawing.Point(168, 80);
			this.GameInfo_Current_NbChallenge.Name = "GameInfo_Current_NbChallenge";
			this.GameInfo_Current_NbChallenge.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_NbChallenge.TabIndex = 19;
			this.GameInfo_Current_NbChallenge.Text = "";
			// 
			// GameInfo_Current_RoundPointsLimit
			// 
			this.GameInfo_Current_RoundPointsLimit.Location = new System.Drawing.Point(168, 104);
			this.GameInfo_Current_RoundPointsLimit.Name = "GameInfo_Current_RoundPointsLimit";
			this.GameInfo_Current_RoundPointsLimit.Size = new System.Drawing.Size(144, 20);
			this.GameInfo_Current_RoundPointsLimit.TabIndex = 18;
			this.GameInfo_Current_RoundPointsLimit.Text = "";
			// 
			// GameInfo_Next_TeamUseNewRules
			// 
			this.GameInfo_Next_TeamUseNewRules.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GameInfo_Next_TeamUseNewRules.Location = new System.Drawing.Point(352, 224);
			this.GameInfo_Next_TeamUseNewRules.Name = "GameInfo_Next_TeamUseNewRules";
			this.GameInfo_Next_TeamUseNewRules.Size = new System.Drawing.Size(144, 24);
			this.GameInfo_Next_TeamUseNewRules.TabIndex = 9;
			// 
			// GameInfo_Next_RoundUseNewRules
			// 
			this.GameInfo_Next_RoundUseNewRules.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GameInfo_Next_RoundUseNewRules.Location = new System.Drawing.Point(352, 128);
			this.GameInfo_Next_RoundUseNewRules.Name = "GameInfo_Next_RoundUseNewRules";
			this.GameInfo_Next_RoundUseNewRules.Size = new System.Drawing.Size(144, 24);
			this.GameInfo_Next_RoundUseNewRules.TabIndex = 5;
			// 
			// GameInfo_Current_TeamUseNewRules
			// 
			this.GameInfo_Current_TeamUseNewRules.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GameInfo_Current_TeamUseNewRules.Location = new System.Drawing.Point(168, 224);
			this.GameInfo_Current_TeamUseNewRules.Name = "GameInfo_Current_TeamUseNewRules";
			this.GameInfo_Current_TeamUseNewRules.Size = new System.Drawing.Size(144, 24);
			this.GameInfo_Current_TeamUseNewRules.TabIndex = 15;
			// 
			// GameInfo_Current_RoundUseNewRules
			// 
			this.GameInfo_Current_RoundUseNewRules.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GameInfo_Current_RoundUseNewRules.Location = new System.Drawing.Point(168, 128);
			this.GameInfo_Current_RoundUseNewRules.Name = "GameInfo_Current_RoundUseNewRules";
			this.GameInfo_Current_RoundUseNewRules.Size = new System.Drawing.Size(144, 24);
			this.GameInfo_Current_RoundUseNewRules.TabIndex = 14;
			// 
			// label23
			// 
			this.label23.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label23.Location = new System.Drawing.Point(352, 8);
			this.label23.Name = "label23";
			this.label23.Size = new System.Drawing.Size(144, 23);
			this.label23.TabIndex = 13;
			this.label23.Tag = "Next";
			this.label23.Text = "Next";
			this.label23.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label22
			// 
			this.label22.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label22.Location = new System.Drawing.Point(168, 8);
			this.label22.Name = "label22";
			this.label22.Size = new System.Drawing.Size(144, 23);
			this.label22.TabIndex = 12;
			this.label22.Tag = "Current";
			this.label22.Text = "Current";
			this.label22.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label21
			// 
			this.label21.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label21.Location = new System.Drawing.Point(8, 224);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(156, 23);
			this.label21.TabIndex = 11;
			this.label21.Tag = "Team - Use New Rules :";
			this.label21.Text = "Team - Use New Rules :";
			this.label21.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label20
			// 
			this.label20.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label20.Location = new System.Drawing.Point(8, 248);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(156, 23);
			this.label20.TabIndex = 10;
			this.label20.Tag = "Laps - Nb Laps :";
			this.label20.Text = "Laps - Nb Laps :";
			this.label20.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label19
			// 
			this.label19.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label19.Location = new System.Drawing.Point(8, 272);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(156, 23);
			this.label19.TabIndex = 9;
			this.label19.Tag = "Laps - Time Limit :";
			this.label19.Text = "Laps - Time Limit :";
			this.label19.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label18
			// 
			this.label18.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label18.Location = new System.Drawing.Point(8, 200);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(156, 23);
			this.label18.TabIndex = 8;
			this.label18.Tag = "Team - Max Points :";
			this.label18.Text = "Team - Max Points :";
			this.label18.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label17
			// 
			this.label17.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label17.Location = new System.Drawing.Point(8, 176);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(156, 23);
			this.label17.TabIndex = 7;
			this.label17.Tag = "Team - Points Limit :";
			this.label17.Text = "Team - Points Limit :";
			this.label17.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label16
			// 
			this.label16.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label16.Location = new System.Drawing.Point(8, 152);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(156, 23);
			this.label16.TabIndex = 6;
			this.label16.Tag = "Time Attack - Limit :";
			this.label16.Text = "Time Attack - Limit :";
			this.label16.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label15
			// 
			this.label15.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label15.Location = new System.Drawing.Point(8, 128);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(156, 23);
			this.label15.TabIndex = 5;
			this.label15.Tag = "Round - Use New Rules :";
			this.label15.Text = "Round - Use New Rules :";
			this.label15.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label14
			// 
			this.label14.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label14.Location = new System.Drawing.Point(8, 104);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(156, 23);
			this.label14.TabIndex = 4;
			this.label14.Tag = "Round - Points Limit :";
			this.label14.Text = "Round - Points Limit :";
			this.label14.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label13
			// 
			this.label13.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label13.Location = new System.Drawing.Point(8, 80);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(156, 23);
			this.label13.TabIndex = 3;
			this.label13.Tag = "Nb Challenge :";
			this.label13.Text = "Nb Challenge :";
			this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label12
			// 
			this.label12.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label12.Location = new System.Drawing.Point(8, 56);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(156, 23);
			this.label12.TabIndex = 2;
			this.label12.Tag = "Chat Time :";
			this.label12.Text = "Chat Time :";
			this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label11
			// 
			this.label11.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label11.Location = new System.Drawing.Point(8, 32);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(156, 23);
			this.label11.TabIndex = 1;
			this.label11.Tag = "Game Mode :";
			this.label11.Text = "Game Mode :";
			this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label10
			// 
			this.label10.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label10.Location = new System.Drawing.Point(8, 104);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(144, 23);
			this.label10.TabIndex = 4;
			this.label10.Text = "label14";
			// 
			// label24
			// 
			this.label24.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label24.Location = new System.Drawing.Point(8, 56);
			this.label24.Name = "label24";
			this.label24.Size = new System.Drawing.Size(144, 23);
			this.label24.TabIndex = 2;
			this.label24.Text = "label12";
			// 
			// label25
			// 
			this.label25.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label25.Location = new System.Drawing.Point(8, 80);
			this.label25.Name = "label25";
			this.label25.Size = new System.Drawing.Size(144, 23);
			this.label25.TabIndex = 3;
			this.label25.Text = "label13";
			// 
			// label26
			// 
			this.label26.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label26.Location = new System.Drawing.Point(8, 32);
			this.label26.Name = "label26";
			this.label26.Size = new System.Drawing.Size(144, 23);
			this.label26.TabIndex = 1;
			this.label26.Text = "Game Mode :";
			// 
			// label27
			// 
			this.label27.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label27.Location = new System.Drawing.Point(8, 128);
			this.label27.Name = "label27";
			this.label27.Size = new System.Drawing.Size(144, 23);
			this.label27.TabIndex = 5;
			this.label27.Text = "label15";
			// 
			// label28
			// 
			this.label28.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label28.Location = new System.Drawing.Point(8, 152);
			this.label28.Name = "label28";
			this.label28.Size = new System.Drawing.Size(144, 23);
			this.label28.TabIndex = 6;
			this.label28.Text = "label16";
			// 
			// tabPage3
			// 
			this.tabPage3.Controls.Add(this.groupBox8);
			this.tabPage3.Controls.Add(this.groupBox4);
			this.tabPage3.Controls.Add(this.groupBox3);
			this.tabPage3.Controls.Add(this.groupBox2);
			this.tabPage3.Location = new System.Drawing.Point(4, 25);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Size = new System.Drawing.Size(592, 395);
			this.tabPage3.TabIndex = 2;
			this.tabPage3.Tag = "Map Control";
			this.tabPage3.Text = "Map Control";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.MapControl_PlaylistOK);
			this.groupBox4.Controls.Add(this.MapControl_AddPlaylist);
			this.groupBox4.Controls.Add(this.MapControl_InsertPlaylist);
			this.groupBox4.Controls.Add(this.MapControl_ExportPlaylist);
			this.groupBox4.Controls.Add(this.MapControl_ImportPlaylist);
			this.groupBox4.Controls.Add(this.MapControl_EditPlaylistName);
			this.groupBox4.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox4.Location = new System.Drawing.Point(344, 272);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(240, 120);
			this.groupBox4.TabIndex = 2;
			this.groupBox4.TabStop = false;
			this.groupBox4.Tag = "MatchSettings Management";
			this.groupBox4.Text = "MatchSettings Management";
			// 
			// MapControl_PlaylistOK
			// 
			this.MapControl_PlaylistOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_PlaylistOK.Location = new System.Drawing.Point(192, 88);
			this.MapControl_PlaylistOK.Name = "MapControl_PlaylistOK";
			this.MapControl_PlaylistOK.Size = new System.Drawing.Size(32, 23);
			this.MapControl_PlaylistOK.TabIndex = 5;
			this.MapControl_PlaylistOK.Tag = "Ok";
			this.MapControl_PlaylistOK.Text = "Ok";
			this.MapControl_PlaylistOK.Click += new System.EventHandler(this.MapControl_PlaylistOK_Click);
			// 
			// MapControl_AddPlaylist
			// 
			this.MapControl_AddPlaylist.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_AddPlaylist.Location = new System.Drawing.Point(16, 56);
			this.MapControl_AddPlaylist.Name = "MapControl_AddPlaylist";
			this.MapControl_AddPlaylist.Size = new System.Drawing.Size(100, 23);
			this.MapControl_AddPlaylist.TabIndex = 4;
			this.MapControl_AddPlaylist.Tag = "Add Playlist";
			this.MapControl_AddPlaylist.Text = "Add Playlist";
			this.MapControl_AddPlaylist.Click += new System.EventHandler(this.MapControl_AddPlaylist_Click);
			// 
			// MapControl_InsertPlaylist
			// 
			this.MapControl_InsertPlaylist.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_InsertPlaylist.Location = new System.Drawing.Point(128, 56);
			this.MapControl_InsertPlaylist.Name = "MapControl_InsertPlaylist";
			this.MapControl_InsertPlaylist.Size = new System.Drawing.Size(100, 23);
			this.MapControl_InsertPlaylist.TabIndex = 3;
			this.MapControl_InsertPlaylist.Tag = "Insert Playlist";
			this.MapControl_InsertPlaylist.Text = "Insert Playlist";
			this.MapControl_InsertPlaylist.Click += new System.EventHandler(this.MapControl_InsertPlaylist_Click);
			// 
			// MapControl_ExportPlaylist
			// 
			this.MapControl_ExportPlaylist.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_ExportPlaylist.Location = new System.Drawing.Point(128, 24);
			this.MapControl_ExportPlaylist.Name = "MapControl_ExportPlaylist";
			this.MapControl_ExportPlaylist.Size = new System.Drawing.Size(100, 23);
			this.MapControl_ExportPlaylist.TabIndex = 2;
			this.MapControl_ExportPlaylist.Tag = "Save";
			this.MapControl_ExportPlaylist.Text = "Save";
			this.MapControl_ExportPlaylist.Click += new System.EventHandler(this.MapControl_ExportPlaylist_Click);
			// 
			// MapControl_ImportPlaylist
			// 
			this.MapControl_ImportPlaylist.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_ImportPlaylist.Location = new System.Drawing.Point(16, 24);
			this.MapControl_ImportPlaylist.Name = "MapControl_ImportPlaylist";
			this.MapControl_ImportPlaylist.Size = new System.Drawing.Size(100, 23);
			this.MapControl_ImportPlaylist.TabIndex = 1;
			this.MapControl_ImportPlaylist.Tag = "Load";
			this.MapControl_ImportPlaylist.Text = "Load";
			this.MapControl_ImportPlaylist.Click += new System.EventHandler(this.MapControl_ImportPlaylist_Click);
			// 
			// MapControl_EditPlaylistName
			// 
			this.MapControl_EditPlaylistName.Location = new System.Drawing.Point(8, 88);
			this.MapControl_EditPlaylistName.Name = "MapControl_EditPlaylistName";
			this.MapControl_EditPlaylistName.Size = new System.Drawing.Size(176, 20);
			this.MapControl_EditPlaylistName.TabIndex = 0;
			this.MapControl_EditPlaylistName.Text = "";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.MapControl_EditFilename);
			this.groupBox3.Controls.Add(this.MapControl_Remove);
			this.groupBox3.Controls.Add(this.MapControl_Add);
			this.groupBox3.Controls.Add(this.MapControl_NextMap);
			this.groupBox3.Controls.Add(this.MapControl_Restart);
			this.groupBox3.Controls.Add(this.MapControl_Browser);
			this.groupBox3.Controls.Add(this.MapControl_BrowseChallenge);
			this.groupBox3.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox3.Location = new System.Drawing.Point(8, 160);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(320, 232);
			this.groupBox3.TabIndex = 1;
			this.groupBox3.TabStop = false;
			this.groupBox3.Tag = "Challenge Center";
			this.groupBox3.Text = "Challenge Center";
			// 
			// MapControl_EditFilename
			// 
			this.MapControl_EditFilename.Location = new System.Drawing.Point(8, 208);
			this.MapControl_EditFilename.Name = "MapControl_EditFilename";
			this.MapControl_EditFilename.Size = new System.Drawing.Size(280, 20);
			this.MapControl_EditFilename.TabIndex = 6;
			this.MapControl_EditFilename.Text = "";
			// 
			// MapControl_Remove
			// 
			this.MapControl_Remove.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_Remove.Location = new System.Drawing.Point(248, 176);
			this.MapControl_Remove.Name = "MapControl_Remove";
			this.MapControl_Remove.Size = new System.Drawing.Size(64, 23);
			this.MapControl_Remove.TabIndex = 5;
			this.MapControl_Remove.Tag = "Remove";
			this.MapControl_Remove.Text = "Remove";
			this.MapControl_Remove.Click += new System.EventHandler(this.MapControl_Remove_Click);
			// 
			// MapControl_Add
			// 
			this.MapControl_Add.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_Add.Location = new System.Drawing.Point(248, 144);
			this.MapControl_Add.Name = "MapControl_Add";
			this.MapControl_Add.Size = new System.Drawing.Size(64, 23);
			this.MapControl_Add.TabIndex = 4;
			this.MapControl_Add.Tag = "Add";
			this.MapControl_Add.Text = "Add";
			this.MapControl_Add.Click += new System.EventHandler(this.MapControl_Add_Click);
			// 
			// MapControl_NextMap
			// 
			this.MapControl_NextMap.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_NextMap.Location = new System.Drawing.Point(248, 56);
			this.MapControl_NextMap.Name = "MapControl_NextMap";
			this.MapControl_NextMap.Size = new System.Drawing.Size(64, 23);
			this.MapControl_NextMap.TabIndex = 3;
			this.MapControl_NextMap.Tag = "Next Map";
			this.MapControl_NextMap.Text = "Next Map";
			this.MapControl_NextMap.Click += new System.EventHandler(this.MapControl_NextMap_Click);
			// 
			// MapControl_Restart
			// 
			this.MapControl_Restart.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_Restart.Location = new System.Drawing.Point(248, 24);
			this.MapControl_Restart.Name = "MapControl_Restart";
			this.MapControl_Restart.Size = new System.Drawing.Size(64, 23);
			this.MapControl_Restart.TabIndex = 1;
			this.MapControl_Restart.Tag = "Restart";
			this.MapControl_Restart.Text = "Restart";
			this.MapControl_Restart.Click += new System.EventHandler(this.MapControl_Restart_Click);
			// 
			// MapControl_Browser
			// 
			this.MapControl_Browser.Location = new System.Drawing.Point(8, 24);
			this.MapControl_Browser.Name = "MapControl_Browser";
			this.MapControl_Browser.Size = new System.Drawing.Size(232, 176);
			this.MapControl_Browser.TabIndex = 0;
			this.MapControl_Browser.View = System.Windows.Forms.View.List;
			this.MapControl_Browser.SelectedIndexChanged += new System.EventHandler(this.MapControl_Browser_SelectedIndexChanged);
			// 
			// MapControl_BrowseChallenge
			// 
			this.MapControl_BrowseChallenge.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_BrowseChallenge.Image = ((System.Drawing.Image)(resources.GetObject("MapControl_BrowseChallenge.Image")));
			this.MapControl_BrowseChallenge.Location = new System.Drawing.Point(296, 208);
			this.MapControl_BrowseChallenge.Name = "MapControl_BrowseChallenge";
			this.MapControl_BrowseChallenge.Size = new System.Drawing.Size(16, 16);
			this.MapControl_BrowseChallenge.TabIndex = 7;
			this.MapControl_BrowseChallenge.Click += new System.EventHandler(this.MapControl_BrowseChallenge_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.MapControl_GoldTime);
			this.groupBox2.Controls.Add(this.MapControl_Filename);
			this.groupBox2.Controls.Add(this.MapControl_Mood);
			this.groupBox2.Controls.Add(this.MapControl_ChallengeName);
			this.groupBox2.Controls.Add(this.label33);
			this.groupBox2.Controls.Add(this.label30);
			this.groupBox2.Controls.Add(this.label29);
			this.groupBox2.Controls.Add(this.label32);
			this.groupBox2.Controls.Add(this.MapControl_Environment);
			this.groupBox2.Controls.Add(this.label34);
			this.groupBox2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox2.Location = new System.Drawing.Point(8, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(576, 144);
			this.groupBox2.TabIndex = 0;
			this.groupBox2.TabStop = false;
			this.groupBox2.Tag = "Challenge Info";
			this.groupBox2.Text = "Challenge Info";
			// 
			// MapControl_GoldTime
			// 
			this.MapControl_GoldTime.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_GoldTime.Location = new System.Drawing.Point(152, 72);
			this.MapControl_GoldTime.Name = "MapControl_GoldTime";
			this.MapControl_GoldTime.Size = new System.Drawing.Size(400, 23);
			this.MapControl_GoldTime.TabIndex = 9;
			this.MapControl_GoldTime.Text = "label38";
			// 
			// MapControl_Filename
			// 
			this.MapControl_Filename.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_Filename.Location = new System.Drawing.Point(152, 48);
			this.MapControl_Filename.Name = "MapControl_Filename";
			this.MapControl_Filename.Size = new System.Drawing.Size(400, 23);
			this.MapControl_Filename.TabIndex = 8;
			this.MapControl_Filename.Text = "label37";
			// 
			// MapControl_Mood
			// 
			this.MapControl_Mood.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_Mood.Location = new System.Drawing.Point(152, 96);
			this.MapControl_Mood.Name = "MapControl_Mood";
			this.MapControl_Mood.Size = new System.Drawing.Size(400, 23);
			this.MapControl_Mood.TabIndex = 7;
			this.MapControl_Mood.Text = "label36";
			// 
			// MapControl_ChallengeName
			// 
			this.MapControl_ChallengeName.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_ChallengeName.Location = new System.Drawing.Point(152, 24);
			this.MapControl_ChallengeName.Name = "MapControl_ChallengeName";
			this.MapControl_ChallengeName.Size = new System.Drawing.Size(400, 23);
			this.MapControl_ChallengeName.TabIndex = 5;
			this.MapControl_ChallengeName.Text = "label31";
			// 
			// label33
			// 
			this.label33.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label33.Location = new System.Drawing.Point(8, 96);
			this.label33.Name = "label33";
			this.label33.Size = new System.Drawing.Size(144, 23);
			this.label33.TabIndex = 3;
			this.label33.Tag = "Mood :";
			this.label33.Text = "Mood :";
			// 
			// label30
			// 
			this.label30.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label30.Location = new System.Drawing.Point(8, 48);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(144, 23);
			this.label30.TabIndex = 1;
			this.label30.Tag = "File Name :";
			this.label30.Text = "File Name :";
			// 
			// label29
			// 
			this.label29.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label29.Location = new System.Drawing.Point(8, 24);
			this.label29.Name = "label29";
			this.label29.Size = new System.Drawing.Size(144, 23);
			this.label29.TabIndex = 0;
			this.label29.Tag = "Challenge Name :";
			this.label29.Text = "Challenge Name :";
			// 
			// label32
			// 
			this.label32.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label32.Location = new System.Drawing.Point(8, 72);
			this.label32.Name = "label32";
			this.label32.Size = new System.Drawing.Size(144, 23);
			this.label32.TabIndex = 2;
			this.label32.Tag = "Gold Time :";
			this.label32.Text = "Gold Time :";
			// 
			// MapControl_Environment
			// 
			this.MapControl_Environment.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.MapControl_Environment.Location = new System.Drawing.Point(152, 120);
			this.MapControl_Environment.Name = "MapControl_Environment";
			this.MapControl_Environment.Size = new System.Drawing.Size(400, 16);
			this.MapControl_Environment.TabIndex = 6;
			this.MapControl_Environment.Text = "label35";
			// 
			// label34
			// 
			this.label34.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label34.Location = new System.Drawing.Point(8, 120);
			this.label34.Name = "label34";
			this.label34.Size = new System.Drawing.Size(144, 16);
			this.label34.TabIndex = 4;
			this.label34.Tag = "Environment :";
			this.label34.Text = "Environment :";
			// 
			// tabPage4
			// 
			this.tabPage4.Controls.Add(this.groupBox9);
			this.tabPage4.Controls.Add(this.groupBox6);
			this.tabPage4.Controls.Add(this.groupBox5);
			this.tabPage4.Controls.Add(this.groupBox7);
			this.tabPage4.Location = new System.Drawing.Point(4, 25);
			this.tabPage4.Name = "tabPage4";
			this.tabPage4.Size = new System.Drawing.Size(592, 395);
			this.tabPage4.TabIndex = 3;
			this.tabPage4.Tag = "Player Control";
			this.tabPage4.Text = "Player Control";
			// 
			// groupBox9
			// 
			this.groupBox9.Controls.Add(this.PlayerControl_BlackBrowser);
			this.groupBox9.Controls.Add(this.PlayerControl_CleanBlack);
			this.groupBox9.Controls.Add(this.PlayerControl_Unblack);
			this.groupBox9.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox9.Location = new System.Drawing.Point(304, 192);
			this.groupBox9.Name = "groupBox9";
			this.groupBox9.Size = new System.Drawing.Size(280, 200);
			this.groupBox9.TabIndex = 4;
			this.groupBox9.TabStop = false;
			this.groupBox9.Tag = "Black List";
			this.groupBox9.Text = "Black List";
			// 
			// PlayerControl_BlackBrowser
			// 
			this.PlayerControl_BlackBrowser.Location = new System.Drawing.Point(8, 24);
			this.PlayerControl_BlackBrowser.Name = "PlayerControl_BlackBrowser";
			this.PlayerControl_BlackBrowser.Size = new System.Drawing.Size(192, 168);
			this.PlayerControl_BlackBrowser.TabIndex = 8;
			this.PlayerControl_BlackBrowser.View = System.Windows.Forms.View.List;
			// 
			// PlayerControl_CleanBlack
			// 
			this.PlayerControl_CleanBlack.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_CleanBlack.Location = new System.Drawing.Point(208, 56);
			this.PlayerControl_CleanBlack.Name = "PlayerControl_CleanBlack";
			this.PlayerControl_CleanBlack.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_CleanBlack.TabIndex = 7;
			this.PlayerControl_CleanBlack.Tag = "Clear";
			this.PlayerControl_CleanBlack.Text = "Clear";
			this.PlayerControl_CleanBlack.Click += new System.EventHandler(this.PlayerControl_CleanBlack_Click);
			// 
			// PlayerControl_Unblack
			// 
			this.PlayerControl_Unblack.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Unblack.Location = new System.Drawing.Point(208, 24);
			this.PlayerControl_Unblack.Name = "PlayerControl_Unblack";
			this.PlayerControl_Unblack.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_Unblack.TabIndex = 6;
			this.PlayerControl_Unblack.Tag = "Unblack";
			this.PlayerControl_Unblack.Text = "Unblack";
			this.PlayerControl_Unblack.Click += new System.EventHandler(this.PlayerControl_Unblack_Click);
			// 
			// groupBox6
			// 
			this.groupBox6.Controls.Add(this.PlayerControl_Black);
			this.groupBox6.Controls.Add(this.PlayerControl_Kick);
			this.groupBox6.Controls.Add(this.PlayerControl_Ban);
			this.groupBox6.Controls.Add(this.PlayerControl_PlayerBrowser);
			this.groupBox6.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox6.Location = new System.Drawing.Point(8, 136);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(288, 256);
			this.groupBox6.TabIndex = 1;
			this.groupBox6.TabStop = false;
			this.groupBox6.Tag = "Player Browser";
			this.groupBox6.Text = "Player Browser";
			// 
			// PlayerControl_Black
			// 
			this.PlayerControl_Black.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Black.Location = new System.Drawing.Point(216, 88);
			this.PlayerControl_Black.Name = "PlayerControl_Black";
			this.PlayerControl_Black.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_Black.TabIndex = 4;
			this.PlayerControl_Black.Tag = "Black";
			this.PlayerControl_Black.Text = "Black";
			this.PlayerControl_Black.Click += new System.EventHandler(this.PlayerControl_Black_Click);
			// 
			// PlayerControl_Kick
			// 
			this.PlayerControl_Kick.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Kick.Location = new System.Drawing.Point(216, 24);
			this.PlayerControl_Kick.Name = "PlayerControl_Kick";
			this.PlayerControl_Kick.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_Kick.TabIndex = 2;
			this.PlayerControl_Kick.Tag = "Kick";
			this.PlayerControl_Kick.Text = "Kick";
			this.PlayerControl_Kick.Click += new System.EventHandler(this.PlayerControl_Kick_Click);
			// 
			// PlayerControl_Ban
			// 
			this.PlayerControl_Ban.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Ban.Location = new System.Drawing.Point(216, 56);
			this.PlayerControl_Ban.Name = "PlayerControl_Ban";
			this.PlayerControl_Ban.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_Ban.TabIndex = 1;
			this.PlayerControl_Ban.Tag = "Ban";
			this.PlayerControl_Ban.Text = "Ban";
			this.PlayerControl_Ban.Click += new System.EventHandler(this.PlayerControl_Ban_Click);
			// 
			// PlayerControl_PlayerBrowser
			// 
			this.PlayerControl_PlayerBrowser.Location = new System.Drawing.Point(8, 24);
			this.PlayerControl_PlayerBrowser.Name = "PlayerControl_PlayerBrowser";
			this.PlayerControl_PlayerBrowser.Size = new System.Drawing.Size(200, 224);
			this.PlayerControl_PlayerBrowser.TabIndex = 0;
			this.PlayerControl_PlayerBrowser.View = System.Windows.Forms.View.List;
			this.PlayerControl_PlayerBrowser.SelectedIndexChanged += new System.EventHandler(this.PlayerControl_PlayerBrowser_SelectedIndexChanged);
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.PlayerControl_Ranking);
			this.groupBox5.Controls.Add(this.PlayerControl_Id);
			this.groupBox5.Controls.Add(this.PlayerControl_Nickname);
			this.groupBox5.Controls.Add(this.PlayerControl_Login);
			this.groupBox5.Controls.Add(this.label42);
			this.groupBox5.Controls.Add(this.label41);
			this.groupBox5.Controls.Add(this.label40);
			this.groupBox5.Controls.Add(this.label39);
			this.groupBox5.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox5.Location = new System.Drawing.Point(8, 8);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(288, 120);
			this.groupBox5.TabIndex = 0;
			this.groupBox5.TabStop = false;
			this.groupBox5.Tag = "Player Info";
			this.groupBox5.Text = "Player Info";
			// 
			// PlayerControl_Ranking
			// 
			this.PlayerControl_Ranking.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Ranking.Location = new System.Drawing.Point(112, 96);
			this.PlayerControl_Ranking.Name = "PlayerControl_Ranking";
			this.PlayerControl_Ranking.Size = new System.Drawing.Size(160, 16);
			this.PlayerControl_Ranking.TabIndex = 7;
			this.PlayerControl_Ranking.Text = "label46";
			// 
			// PlayerControl_Id
			// 
			this.PlayerControl_Id.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Id.Location = new System.Drawing.Point(112, 72);
			this.PlayerControl_Id.Name = "PlayerControl_Id";
			this.PlayerControl_Id.Size = new System.Drawing.Size(160, 23);
			this.PlayerControl_Id.TabIndex = 6;
			this.PlayerControl_Id.Text = "label45";
			// 
			// PlayerControl_Nickname
			// 
			this.PlayerControl_Nickname.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Nickname.Location = new System.Drawing.Point(112, 48);
			this.PlayerControl_Nickname.Name = "PlayerControl_Nickname";
			this.PlayerControl_Nickname.Size = new System.Drawing.Size(160, 23);
			this.PlayerControl_Nickname.TabIndex = 5;
			this.PlayerControl_Nickname.Text = "label44";
			// 
			// PlayerControl_Login
			// 
			this.PlayerControl_Login.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Login.Location = new System.Drawing.Point(112, 24);
			this.PlayerControl_Login.Name = "PlayerControl_Login";
			this.PlayerControl_Login.Size = new System.Drawing.Size(160, 23);
			this.PlayerControl_Login.TabIndex = 4;
			this.PlayerControl_Login.Text = "label43";
			// 
			// label42
			// 
			this.label42.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label42.Location = new System.Drawing.Point(8, 96);
			this.label42.Name = "label42";
			this.label42.Size = new System.Drawing.Size(100, 16);
			this.label42.TabIndex = 3;
			this.label42.Tag = "Ranking :";
			this.label42.Text = "Ranking :";
			// 
			// label41
			// 
			this.label41.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label41.Location = new System.Drawing.Point(8, 72);
			this.label41.Name = "label41";
			this.label41.TabIndex = 2;
			this.label41.Tag = "Id :";
			this.label41.Text = "Id :";
			// 
			// label40
			// 
			this.label40.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label40.Location = new System.Drawing.Point(8, 48);
			this.label40.Name = "label40";
			this.label40.TabIndex = 1;
			this.label40.Tag = "Nickname :";
			this.label40.Text = "Nickname :";
			// 
			// label39
			// 
			this.label39.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label39.Location = new System.Drawing.Point(8, 24);
			this.label39.Name = "label39";
			this.label39.TabIndex = 0;
			this.label39.Tag = "Login :";
			this.label39.Text = "Login :";
			// 
			// groupBox7
			// 
			this.groupBox7.Controls.Add(this.PlayerControl_ClearBan);
			this.groupBox7.Controls.Add(this.PlayerControl_BanBrowser);
			this.groupBox7.Controls.Add(this.PlayerControl_Unban);
			this.groupBox7.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox7.Location = new System.Drawing.Point(304, 8);
			this.groupBox7.Name = "groupBox7";
			this.groupBox7.Size = new System.Drawing.Size(280, 176);
			this.groupBox7.TabIndex = 2;
			this.groupBox7.TabStop = false;
			this.groupBox7.Tag = "Ban List";
			this.groupBox7.Text = "Ban List";
			// 
			// PlayerControl_ClearBan
			// 
			this.PlayerControl_ClearBan.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_ClearBan.Location = new System.Drawing.Point(208, 56);
			this.PlayerControl_ClearBan.Name = "PlayerControl_ClearBan";
			this.PlayerControl_ClearBan.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_ClearBan.TabIndex = 5;
			this.PlayerControl_ClearBan.Tag = "Clear";
			this.PlayerControl_ClearBan.Text = "Clear";
			this.PlayerControl_ClearBan.Click += new System.EventHandler(this.PlayerControl_ClearBan_Click);
			// 
			// PlayerControl_BanBrowser
			// 
			this.PlayerControl_BanBrowser.Location = new System.Drawing.Point(8, 24);
			this.PlayerControl_BanBrowser.Name = "PlayerControl_BanBrowser";
			this.PlayerControl_BanBrowser.Size = new System.Drawing.Size(192, 144);
			this.PlayerControl_BanBrowser.TabIndex = 0;
			this.PlayerControl_BanBrowser.View = System.Windows.Forms.View.List;
			// 
			// PlayerControl_Unban
			// 
			this.PlayerControl_Unban.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.PlayerControl_Unban.Location = new System.Drawing.Point(208, 24);
			this.PlayerControl_Unban.Name = "PlayerControl_Unban";
			this.PlayerControl_Unban.Size = new System.Drawing.Size(64, 23);
			this.PlayerControl_Unban.TabIndex = 4;
			this.PlayerControl_Unban.Tag = "Unban";
			this.PlayerControl_Unban.Text = "Unban";
			this.PlayerControl_Unban.Click += new System.EventHandler(this.PlayerControl_Unban_Click);
			// 
			// tabPage5
			// 
			this.tabPage5.Controls.Add(this.groupBox11);
			this.tabPage5.Controls.Add(this.groupBox10);
			this.tabPage5.Location = new System.Drawing.Point(4, 25);
			this.tabPage5.Name = "tabPage5";
			this.tabPage5.Size = new System.Drawing.Size(592, 395);
			this.tabPage5.TabIndex = 4;
			this.tabPage5.Tag = "Server Stats";
			this.tabPage5.Text = "Server Stats";
			// 
			// groupBox11
			// 
			this.groupBox11.Controls.Add(this.ServerStats_PacketLoss);
			this.groupBox11.Controls.Add(this.ServerStats_Delta);
			this.groupBox11.Controls.Add(this.ServerStats_LastTransfertTime);
			this.groupBox11.Controls.Add(this.ServerStats_IPAddress);
			this.groupBox11.Controls.Add(this.ServerStats_Login);
			this.groupBox11.Controls.Add(this.label59);
			this.groupBox11.Controls.Add(this.label58);
			this.groupBox11.Controls.Add(this.label57);
			this.groupBox11.Controls.Add(this.label56);
			this.groupBox11.Controls.Add(this.label46);
			this.groupBox11.Controls.Add(this.ServerStats_Browser);
			this.groupBox11.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox11.Location = new System.Drawing.Point(280, 8);
			this.groupBox11.Name = "groupBox11";
			this.groupBox11.Size = new System.Drawing.Size(304, 280);
			this.groupBox11.TabIndex = 1;
			this.groupBox11.TabStop = false;
			this.groupBox11.Tag = "Player Stats";
			this.groupBox11.Text = "Player Stats";
			// 
			// ServerStats_PacketLoss
			// 
			this.ServerStats_PacketLoss.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_PacketLoss.Location = new System.Drawing.Point(176, 256);
			this.ServerStats_PacketLoss.Name = "ServerStats_PacketLoss";
			this.ServerStats_PacketLoss.Size = new System.Drawing.Size(100, 16);
			this.ServerStats_PacketLoss.TabIndex = 11;
			this.ServerStats_PacketLoss.Text = "label63";
			// 
			// ServerStats_Delta
			// 
			this.ServerStats_Delta.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_Delta.Location = new System.Drawing.Point(176, 232);
			this.ServerStats_Delta.Name = "ServerStats_Delta";
			this.ServerStats_Delta.TabIndex = 10;
			this.ServerStats_Delta.Text = "label62";
			// 
			// ServerStats_LastTransfertTime
			// 
			this.ServerStats_LastTransfertTime.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_LastTransfertTime.Location = new System.Drawing.Point(176, 208);
			this.ServerStats_LastTransfertTime.Name = "ServerStats_LastTransfertTime";
			this.ServerStats_LastTransfertTime.TabIndex = 9;
			this.ServerStats_LastTransfertTime.Text = "label61";
			// 
			// ServerStats_IPAddress
			// 
			this.ServerStats_IPAddress.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_IPAddress.Location = new System.Drawing.Point(176, 184);
			this.ServerStats_IPAddress.Name = "ServerStats_IPAddress";
			this.ServerStats_IPAddress.TabIndex = 8;
			this.ServerStats_IPAddress.Text = "label60";
			// 
			// ServerStats_Login
			// 
			this.ServerStats_Login.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_Login.Location = new System.Drawing.Point(176, 160);
			this.ServerStats_Login.Name = "ServerStats_Login";
			this.ServerStats_Login.TabIndex = 7;
			this.ServerStats_Login.Text = "label55";
			// 
			// label59
			// 
			this.label59.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label59.Location = new System.Drawing.Point(8, 184);
			this.label59.Name = "label59";
			this.label59.Size = new System.Drawing.Size(168, 23);
			this.label59.TabIndex = 6;
			this.label59.Tag = "IP Adress :";
			this.label59.Text = "IPAddress :";
			// 
			// label58
			// 
			this.label58.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label58.Location = new System.Drawing.Point(8, 208);
			this.label58.Name = "label58";
			this.label58.Size = new System.Drawing.Size(168, 23);
			this.label58.TabIndex = 5;
			this.label58.Tag = "Last Transfert Time :";
			this.label58.Text = "Last Transfert Time :";
			// 
			// label57
			// 
			this.label57.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label57.Location = new System.Drawing.Point(8, 232);
			this.label57.Name = "label57";
			this.label57.Size = new System.Drawing.Size(168, 23);
			this.label57.TabIndex = 4;
			this.label57.Tag = "Delta State :";
			this.label57.Text = "Delta State :";
			// 
			// label56
			// 
			this.label56.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label56.Location = new System.Drawing.Point(8, 256);
			this.label56.Name = "label56";
			this.label56.Size = new System.Drawing.Size(168, 16);
			this.label56.TabIndex = 3;
			this.label56.Tag = "Packet Loss Rate :";
			this.label56.Text = "PacketLossRate :";
			// 
			// label46
			// 
			this.label46.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label46.Location = new System.Drawing.Point(8, 160);
			this.label46.Name = "label46";
			this.label46.Size = new System.Drawing.Size(168, 23);
			this.label46.TabIndex = 1;
			this.label46.Tag = "Login :";
			this.label46.Text = "Login :";
			// 
			// ServerStats_Browser
			// 
			this.ServerStats_Browser.Location = new System.Drawing.Point(8, 24);
			this.ServerStats_Browser.Name = "ServerStats_Browser";
			this.ServerStats_Browser.Size = new System.Drawing.Size(288, 128);
			this.ServerStats_Browser.TabIndex = 0;
			this.ServerStats_Browser.View = System.Windows.Forms.View.List;
			this.ServerStats_Browser.SelectedIndexChanged += new System.EventHandler(this.ServerStats_Browser_SelectedIndexChanged);
			// 
			// groupBox10
			// 
			this.groupBox10.Controls.Add(this.ServerStats_SendNetRate);
			this.groupBox10.Controls.Add(this.ServerStats_RecNetRate);
			this.groupBox10.Controls.Add(this.ServerStats_TotalReceivingSize);
			this.groupBox10.Controls.Add(this.ServerStats_TotalSendingSize);
			this.groupBox10.Controls.Add(this.ServerStats_MeanNbPlayer);
			this.groupBox10.Controls.Add(this.ServerStats_NbConnections);
			this.groupBox10.Controls.Add(this.ServerStats_MeanConnectionTime);
			this.groupBox10.Controls.Add(this.ServerStats_Uptime);
			this.groupBox10.Controls.Add(this.label54);
			this.groupBox10.Controls.Add(this.label53);
			this.groupBox10.Controls.Add(this.label52);
			this.groupBox10.Controls.Add(this.label51);
			this.groupBox10.Controls.Add(this.label45);
			this.groupBox10.Controls.Add(this.label44);
			this.groupBox10.Controls.Add(this.label43);
			this.groupBox10.Controls.Add(this.label38);
			this.groupBox10.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox10.Location = new System.Drawing.Point(8, 8);
			this.groupBox10.Name = "groupBox10";
			this.groupBox10.Size = new System.Drawing.Size(264, 216);
			this.groupBox10.TabIndex = 0;
			this.groupBox10.TabStop = false;
			this.groupBox10.Text = "Global";
			// 
			// ServerStats_SendNetRate
			// 
			this.ServerStats_SendNetRate.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_SendNetRate.Location = new System.Drawing.Point(144, 144);
			this.ServerStats_SendNetRate.Name = "ServerStats_SendNetRate";
			this.ServerStats_SendNetRate.TabIndex = 16;
			this.ServerStats_SendNetRate.Text = "label61";
			// 
			// ServerStats_RecNetRate
			// 
			this.ServerStats_RecNetRate.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_RecNetRate.Location = new System.Drawing.Point(144, 120);
			this.ServerStats_RecNetRate.Name = "ServerStats_RecNetRate";
			this.ServerStats_RecNetRate.TabIndex = 15;
			this.ServerStats_RecNetRate.Text = "label60";
			// 
			// ServerStats_TotalReceivingSize
			// 
			this.ServerStats_TotalReceivingSize.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_TotalReceivingSize.Location = new System.Drawing.Point(144, 168);
			this.ServerStats_TotalReceivingSize.Name = "ServerStats_TotalReceivingSize";
			this.ServerStats_TotalReceivingSize.TabIndex = 14;
			this.ServerStats_TotalReceivingSize.Text = "label59";
			// 
			// ServerStats_TotalSendingSize
			// 
			this.ServerStats_TotalSendingSize.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_TotalSendingSize.Location = new System.Drawing.Point(144, 192);
			this.ServerStats_TotalSendingSize.Name = "ServerStats_TotalSendingSize";
			this.ServerStats_TotalSendingSize.Size = new System.Drawing.Size(100, 16);
			this.ServerStats_TotalSendingSize.TabIndex = 13;
			this.ServerStats_TotalSendingSize.Text = "label58";
			// 
			// ServerStats_MeanNbPlayer
			// 
			this.ServerStats_MeanNbPlayer.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_MeanNbPlayer.Location = new System.Drawing.Point(144, 96);
			this.ServerStats_MeanNbPlayer.Name = "ServerStats_MeanNbPlayer";
			this.ServerStats_MeanNbPlayer.TabIndex = 12;
			this.ServerStats_MeanNbPlayer.Text = "label57";
			// 
			// ServerStats_NbConnections
			// 
			this.ServerStats_NbConnections.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_NbConnections.Location = new System.Drawing.Point(144, 48);
			this.ServerStats_NbConnections.Name = "ServerStats_NbConnections";
			this.ServerStats_NbConnections.TabIndex = 11;
			this.ServerStats_NbConnections.Text = "label56";
			// 
			// ServerStats_MeanConnectionTime
			// 
			this.ServerStats_MeanConnectionTime.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_MeanConnectionTime.Location = new System.Drawing.Point(144, 72);
			this.ServerStats_MeanConnectionTime.Name = "ServerStats_MeanConnectionTime";
			this.ServerStats_MeanConnectionTime.TabIndex = 10;
			this.ServerStats_MeanConnectionTime.Text = "label55";
			// 
			// ServerStats_Uptime
			// 
			this.ServerStats_Uptime.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ServerStats_Uptime.Location = new System.Drawing.Point(144, 24);
			this.ServerStats_Uptime.Name = "ServerStats_Uptime";
			this.ServerStats_Uptime.TabIndex = 9;
			this.ServerStats_Uptime.Text = "label55";
			// 
			// label54
			// 
			this.label54.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label54.Location = new System.Drawing.Point(8, 120);
			this.label54.Name = "label54";
			this.label54.Size = new System.Drawing.Size(128, 23);
			this.label54.TabIndex = 8;
			this.label54.Tag = "Rec Net Rate :";
			this.label54.Text = "Rec Net Rate :";
			// 
			// label53
			// 
			this.label53.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label53.Location = new System.Drawing.Point(8, 144);
			this.label53.Name = "label53";
			this.label53.Size = new System.Drawing.Size(128, 23);
			this.label53.TabIndex = 7;
			this.label53.Tag = "Send Net Rate :";
			this.label53.Text = "Send Net Rate :";
			// 
			// label52
			// 
			this.label52.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label52.Location = new System.Drawing.Point(8, 168);
			this.label52.Name = "label52";
			this.label52.Size = new System.Drawing.Size(128, 23);
			this.label52.TabIndex = 6;
			this.label52.Tag = "Total Receiving Size :";
			this.label52.Text = "Total Receiving Size :";
			// 
			// label51
			// 
			this.label51.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label51.Location = new System.Drawing.Point(8, 192);
			this.label51.Name = "label51";
			this.label51.Size = new System.Drawing.Size(128, 16);
			this.label51.TabIndex = 5;
			this.label51.Tag = "Total Sending Size :";
			this.label51.Text = "Total Sending Size :";
			// 
			// label45
			// 
			this.label45.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label45.Location = new System.Drawing.Point(8, 96);
			this.label45.Name = "label45";
			this.label45.Size = new System.Drawing.Size(128, 23);
			this.label45.TabIndex = 3;
			this.label45.Tag = "Mean Nb Players :";
			this.label45.Text = "Mean Nb Player :";
			// 
			// label44
			// 
			this.label44.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label44.Location = new System.Drawing.Point(8, 72);
			this.label44.Name = "label44";
			this.label44.Size = new System.Drawing.Size(128, 23);
			this.label44.TabIndex = 2;
			this.label44.Tag = "Mean Connection Time :";
			this.label44.Text = "Mean Connection Time :";
			// 
			// label43
			// 
			this.label43.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label43.Location = new System.Drawing.Point(8, 48);
			this.label43.Name = "label43";
			this.label43.Size = new System.Drawing.Size(128, 23);
			this.label43.TabIndex = 1;
			this.label43.Tag = "Nb Connections :";
			this.label43.Text = "Nb Connections :";
			// 
			// label38
			// 
			this.label38.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label38.Location = new System.Drawing.Point(8, 24);
			this.label38.Name = "label38";
			this.label38.Size = new System.Drawing.Size(128, 23);
			this.label38.TabIndex = 0;
			this.label38.Tag = "Uptime :";
			this.label38.Text = "Uptime :";
			// 
			// tabPage6
			// 
			this.tabPage6.Controls.Add(this.Settings_Edit);
			this.tabPage6.Controls.Add(this.Settings_GamePassword);
			this.tabPage6.Controls.Add(this.Settings_GameLogin);
			this.tabPage6.Controls.Add(this.label65);
			this.tabPage6.Controls.Add(this.label64);
			this.tabPage6.Controls.Add(this.label62);
			this.tabPage6.Controls.Add(this.label60);
			this.tabPage6.Controls.Add(this.Settings_Password);
			this.tabPage6.Controls.Add(this.Settings_Login);
			this.tabPage6.Controls.Add(this.label37);
			this.tabPage6.Controls.Add(this.label36);
			this.tabPage6.Controls.Add(this.Settings_IsInternetServer);
			this.tabPage6.Location = new System.Drawing.Point(4, 25);
			this.tabPage6.Name = "tabPage6";
			this.tabPage6.Size = new System.Drawing.Size(592, 395);
			this.tabPage6.TabIndex = 5;
			this.tabPage6.Tag = "Settings";
			this.tabPage6.Text = "Settings";
			// 
			// Settings_Edit
			// 
			this.Settings_Edit.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Settings_Edit.Location = new System.Drawing.Point(496, 344);
			this.Settings_Edit.Name = "Settings_Edit";
			this.Settings_Edit.Size = new System.Drawing.Size(64, 24);
			this.Settings_Edit.TabIndex = 37;
			this.Settings_Edit.Tag = "Edit";
			this.Settings_Edit.Text = "Edit";
			this.Settings_Edit.Click += new System.EventHandler(this.Settings_Edit_Click);
			// 
			// Settings_GamePassword
			// 
			this.Settings_GamePassword.Location = new System.Drawing.Point(144, 184);
			this.Settings_GamePassword.Name = "Settings_GamePassword";
			this.Settings_GamePassword.PasswordChar = '*';
			this.Settings_GamePassword.Size = new System.Drawing.Size(160, 20);
			this.Settings_GamePassword.TabIndex = 6;
			this.Settings_GamePassword.Text = "";
			// 
			// Settings_GameLogin
			// 
			this.Settings_GameLogin.Location = new System.Drawing.Point(144, 160);
			this.Settings_GameLogin.Name = "Settings_GameLogin";
			this.Settings_GameLogin.Size = new System.Drawing.Size(160, 20);
			this.Settings_GameLogin.TabIndex = 5;
			this.Settings_GameLogin.Text = "";
			// 
			// label65
			// 
			this.label65.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label65.Location = new System.Drawing.Point(40, 184);
			this.label65.Name = "label65";
			this.label65.TabIndex = 27;
			this.label65.Tag = "Password :";
			this.label65.Text = "Password :";
			// 
			// label64
			// 
			this.label64.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label64.Location = new System.Drawing.Point(40, 160);
			this.label64.Name = "label64";
			this.label64.TabIndex = 26;
			this.label64.Tag = "Login :";
			this.label64.Text = "Login :";
			// 
			// label62
			// 
			this.label62.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label62.Location = new System.Drawing.Point(8, 104);
			this.label62.Name = "label62";
			this.label62.Size = new System.Drawing.Size(100, 16);
			this.label62.TabIndex = 24;
			this.label62.Tag = "Internal :";
			this.label62.Text = "Internal :";
			// 
			// label60
			// 
			this.label60.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label60.Location = new System.Drawing.Point(8, 32);
			this.label60.Name = "label60";
			this.label60.TabIndex = 21;
			this.label60.Tag = "Authentification :";
			this.label60.Text = "Authentification :";
			// 
			// Settings_Password
			// 
			this.Settings_Password.Location = new System.Drawing.Point(144, 80);
			this.Settings_Password.Name = "Settings_Password";
			this.Settings_Password.PasswordChar = '*';
			this.Settings_Password.Size = new System.Drawing.Size(160, 20);
			this.Settings_Password.TabIndex = 3;
			this.Settings_Password.Text = "Admin";
			// 
			// Settings_Login
			// 
			this.Settings_Login.Location = new System.Drawing.Point(144, 56);
			this.Settings_Login.Name = "Settings_Login";
			this.Settings_Login.Size = new System.Drawing.Size(160, 20);
			this.Settings_Login.TabIndex = 2;
			this.Settings_Login.Text = "Admin";
			// 
			// label37
			// 
			this.label37.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label37.Location = new System.Drawing.Point(40, 80);
			this.label37.Name = "label37";
			this.label37.Size = new System.Drawing.Size(72, 23);
			this.label37.TabIndex = 15;
			this.label37.Tag = "Password :";
			this.label37.Text = "Password :";
			this.label37.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label36
			// 
			this.label36.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label36.Location = new System.Drawing.Point(40, 56);
			this.label36.Name = "label36";
			this.label36.Size = new System.Drawing.Size(72, 23);
			this.label36.TabIndex = 14;
			this.label36.Tag = "Login :";
			this.label36.Text = "Login :";
			this.label36.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Settings_IsInternetServer
			// 
			this.Settings_IsInternetServer.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Settings_IsInternetServer.Location = new System.Drawing.Point(40, 128);
			this.Settings_IsInternetServer.Name = "Settings_IsInternetServer";
			this.Settings_IsInternetServer.TabIndex = 4;
			this.Settings_IsInternetServer.Tag = "Internet Server";
			this.Settings_IsInternetServer.Text = "Internet Server";
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(776, 136);
			this.pictureBox1.TabIndex = 1;
			this.pictureBox1.TabStop = false;
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.Control_Launch);
			this.groupBox1.Controls.Add(this.Control_AppStatus);
			this.groupBox1.Controls.Add(this.label50);
			this.groupBox1.Controls.Add(this.Control_AuthStatus);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.label49);
			this.groupBox1.Controls.Add(this.label48);
			this.groupBox1.Controls.Add(this.label47);
			this.groupBox1.Controls.Add(this.Control_Load);
			this.groupBox1.Controls.Add(this.Control_Shutdown);
			this.groupBox1.Controls.Add(this.Control_Save);
			this.groupBox1.Controls.Add(this.Control_Refresh);
			this.groupBox1.Controls.Add(this.Control_Stop);
			this.groupBox1.Controls.Add(this.Control_Start);
			this.groupBox1.Controls.Add(this.Control_Status);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox1.Location = new System.Drawing.Point(8, 152);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(176, 416);
			this.groupBox1.TabIndex = 2;
			this.groupBox1.TabStop = false;
			this.groupBox1.Tag = "Control Panel";
			this.groupBox1.Text = "Control Panel";
			// 
			// Control_Launch
			// 
			this.Control_Launch.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Launch.Location = new System.Drawing.Point(96, 176);
			this.Control_Launch.Name = "Control_Launch";
			this.Control_Launch.Size = new System.Drawing.Size(64, 23);
			this.Control_Launch.TabIndex = 23;
			this.Control_Launch.Tag = "Launch";
			this.Control_Launch.Text = "Launch";
			// 
			// Control_AppStatus
			// 
			this.Control_AppStatus.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_AppStatus.Location = new System.Drawing.Point(80, 72);
			this.Control_AppStatus.Name = "Control_AppStatus";
			this.Control_AppStatus.Size = new System.Drawing.Size(88, 24);
			this.Control_AppStatus.TabIndex = 22;
			this.Control_AppStatus.Text = "label2";
			this.Control_AppStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label50
			// 
			this.label50.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label50.Location = new System.Drawing.Point(8, 72);
			this.label50.Name = "label50";
			this.label50.Size = new System.Drawing.Size(72, 23);
			this.label50.TabIndex = 21;
			this.label50.Tag = "App Status :";
			this.label50.Text = "App Status :";
			this.label50.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Control_AuthStatus
			// 
			this.Control_AuthStatus.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_AuthStatus.Location = new System.Drawing.Point(80, 96);
			this.Control_AuthStatus.Name = "Control_AuthStatus";
			this.Control_AuthStatus.Size = new System.Drawing.Size(88, 23);
			this.Control_AuthStatus.TabIndex = 19;
			this.Control_AuthStatus.Text = "label";
			this.Control_AuthStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label2
			// 
			this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 23);
			this.label2.TabIndex = 18;
			this.label2.Tag = "Auth Status :";
			this.label2.Text = "Auth Status :";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label49
			// 
			this.label49.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label49.Location = new System.Drawing.Point(8, 360);
			this.label49.Name = "label49";
			this.label49.Size = new System.Drawing.Size(100, 16);
			this.label49.TabIndex = 13;
			this.label49.Tag = "Config :";
			this.label49.Text = "Config :";
			// 
			// label48
			// 
			this.label48.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label48.Location = new System.Drawing.Point(8, 216);
			this.label48.Name = "label48";
			this.label48.Size = new System.Drawing.Size(100, 16);
			this.label48.TabIndex = 12;
			this.label48.Tag = "Infos :";
			this.label48.Text = "Infos :";
			// 
			// label47
			// 
			this.label47.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label47.Location = new System.Drawing.Point(8, 120);
			this.label47.Name = "label47";
			this.label47.Size = new System.Drawing.Size(100, 16);
			this.label47.TabIndex = 11;
			this.label47.Tag = "Server :";
			this.label47.Text = "Server :";
			// 
			// Control_Load
			// 
			this.Control_Load.Enabled = false;
			this.Control_Load.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Load.Location = new System.Drawing.Point(16, 384);
			this.Control_Load.Name = "Control_Load";
			this.Control_Load.Size = new System.Drawing.Size(64, 24);
			this.Control_Load.TabIndex = 10;
			this.Control_Load.Tag = "Load";
			this.Control_Load.Text = "Load";
			this.Control_Load.Click += new System.EventHandler(this.Control_Load_Click);
			// 
			// Control_Shutdown
			// 
			this.Control_Shutdown.Enabled = false;
			this.Control_Shutdown.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Shutdown.Location = new System.Drawing.Point(96, 144);
			this.Control_Shutdown.Name = "Control_Shutdown";
			this.Control_Shutdown.Size = new System.Drawing.Size(64, 24);
			this.Control_Shutdown.TabIndex = 9;
			this.Control_Shutdown.Tag = "Shutdown";
			this.Control_Shutdown.Text = "Shutdown";
			this.Control_Shutdown.Click += new System.EventHandler(this.Control_Shutdown_Click);
			// 
			// Control_Save
			// 
			this.Control_Save.Enabled = false;
			this.Control_Save.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Save.Location = new System.Drawing.Point(88, 384);
			this.Control_Save.Name = "Control_Save";
			this.Control_Save.Size = new System.Drawing.Size(64, 24);
			this.Control_Save.TabIndex = 8;
			this.Control_Save.Tag = "Save";
			this.Control_Save.Text = "Save";
			this.Control_Save.Click += new System.EventHandler(this.Control_Save_Click);
			// 
			// Control_Refresh
			// 
			this.Control_Refresh.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Refresh.Location = new System.Drawing.Point(16, 240);
			this.Control_Refresh.Name = "Control_Refresh";
			this.Control_Refresh.Size = new System.Drawing.Size(72, 24);
			this.Control_Refresh.TabIndex = 6;
			this.Control_Refresh.Tag = "Refresh";
			this.Control_Refresh.Text = "Refresh";
			this.Control_Refresh.Click += new System.EventHandler(this.Control_Refresh_Click);
			// 
			// Control_Stop
			// 
			this.Control_Stop.Enabled = false;
			this.Control_Stop.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Stop.Location = new System.Drawing.Point(16, 176);
			this.Control_Stop.Name = "Control_Stop";
			this.Control_Stop.Size = new System.Drawing.Size(64, 24);
			this.Control_Stop.TabIndex = 4;
			this.Control_Stop.Tag = "Stop";
			this.Control_Stop.Text = "Stop";
			this.Control_Stop.Click += new System.EventHandler(this.Control_Stop_Click);
			// 
			// Control_Start
			// 
			this.Control_Start.Enabled = false;
			this.Control_Start.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Start.Location = new System.Drawing.Point(16, 144);
			this.Control_Start.Name = "Control_Start";
			this.Control_Start.Size = new System.Drawing.Size(64, 24);
			this.Control_Start.TabIndex = 3;
			this.Control_Start.Tag = "Start";
			this.Control_Start.Text = "Start";
			this.Control_Start.Click += new System.EventHandler(this.Control_Start_Click);
			// 
			// Control_Status
			// 
			this.Control_Status.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.Control_Status.Location = new System.Drawing.Point(80, 24);
			this.Control_Status.Name = "Control_Status";
			this.Control_Status.Size = new System.Drawing.Size(88, 24);
			this.Control_Status.TabIndex = 1;
			this.Control_Status.Text = "label2";
			this.Control_Status.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label1
			// 
			this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label1.Location = new System.Drawing.Point(8, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 0;
			this.label1.Tag = "Server Status :";
			this.label1.Text = "Server Status :";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.CheckFileExists = false;
			this.openFileDialog1.Multiselect = true;
			this.openFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog1_FileOk);
			// 
			// MapControl_EditCurrentChallenge
			// 
			this.MapControl_EditCurrentChallenge.Location = new System.Drawing.Point(8, 24);
			this.MapControl_EditCurrentChallenge.Name = "MapControl_EditCurrentChallenge";
			this.MapControl_EditCurrentChallenge.ReadOnly = true;
			this.MapControl_EditCurrentChallenge.Size = new System.Drawing.Size(224, 20);
			this.MapControl_EditCurrentChallenge.TabIndex = 5;
			this.MapControl_EditCurrentChallenge.Text = "";
			// 
			// groupBox8
			// 
			this.groupBox8.Controls.Add(this.MapControl_EditCurrentChallenge);
			this.groupBox8.Location = new System.Drawing.Point(344, 168);
			this.groupBox8.Name = "groupBox8";
			this.groupBox8.Size = new System.Drawing.Size(240, 72);
			this.groupBox8.TabIndex = 6;
			this.groupBox8.TabStop = false;
			this.groupBox8.Tag = "Current Challenge";
			this.groupBox8.Text = "Current Challenge";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 570);
			this.Controls.Add(this.ServerTab);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.pictureBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "Form1";
			this.Tag = "Trackmania Server Controler";
			this.Text = "Trackmania Server Controler";
			this.ServerTab.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.tabPage3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.tabPage4.ResumeLayout(false);
			this.groupBox9.ResumeLayout(false);
			this.groupBox6.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.groupBox7.ResumeLayout(false);
			this.tabPage5.ResumeLayout(false);
			this.groupBox11.ResumeLayout(false);
			this.groupBox10.ResumeLayout(false);
			this.tabPage6.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox8.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Point d'entre principal de l'application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private void InitializeServerPanels()
		{
			General_Initialize();
			GameInfo_Initialize();
			MapControl_Initialize();
			PlayerControl_Initialize();
		}

		private void InitializeLocalization()
		{
			InitializeRecursive(this);
		}

		private void InitializeRecursive(Control _c)
		{
			try
			{
				_c.Text = Localizer.GetText(_c.Tag.ToString());
			}
			catch 
			{
				_c.Text = "";
			}

			foreach(Control child in _c.Controls)
				InitializeRecursive(child);	
		}
		

		public delegate void VoidDelegate();
		public delegate void VoidDelegateServerOptions(SServerOptions _Options);
		public delegate void VoidDelegateGameInfo(SGameInfo _Infos);
		public delegate void VoidDelegateFullGameInfo(SFullGameInfo _Infos);
		public delegate void VoidDelegateChallengeArray(SChallengeQuickInfo[] _Infos, SChallengeInfo _CurChallengeInfo);
		public delegate void VoidDelegateMegaPlayerInfo(SPlayerQuickInfo[] PlayerInfoArray,
			SPlayerInfoBanned[] PlayerInfoBannedArray,	SPlayerInfoBlack[] PlayerInfoBlackArray);
		public delegate void VoidDelegateNetworkStats(SNetworkStats _Stats);
		public delegate void VoidDelegateBool(bool _Success);
		public delegate void VoidDelegateString(string _name);
		public delegate void VoidDelegateStringArray(string[] _names);
		public delegate void VoidDelegateInt(int _int);
		public delegate void VoidDelegateStatus(SStatus _Status);
		public delegate void VoidDelegateParamNet(SStartServerParamInternet _Param);
		public delegate void VoidDelegateParamLan();
		public delegate void VoidDelegateStringInt(string _s, int _i);

		/*
		 * Control Panel
		 */

		private static bool IsAuth = false;

		private void CheckAuthentification()
		{
			if (Settings_IsEditing)
				return;
			
			bool Success = false;
			try
			{
				Success = Proxy.Authenticate(Settings_Login.Text, Settings_Password.Text);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
				Success = false;
			}
			
			if (Success)
			{
				IsAuth = true;
				Control_AuthStatus.Text = Localizer.GetText("Logged in");
				Settings_Login.Enabled = false;
				Settings_Password.Enabled = false;
			}
			else
			{
				IsAuth = false;
				Control_AuthStatus.Text = Localizer.GetText("Login failed");
				Settings_Login.Enabled = true;
				Settings_Password.Enabled = true;
			}	
		}

		private void CheckStatus()
		{
			SStatus CurrentStatus;
			try
			{
				CurrentStatus = Proxy.GetStatus();
			}
			catch
			{
				CurrentStatus = new SStatus();
				CurrentStatus.SetDefault();
			}			
			
			Control_Status.Text = CurrentStatus.Name;
			Control_Launch.Enabled = Control_Start.Enabled = Control_Stop.Enabled
				= Control_Shutdown.Enabled = false;

            switch(CurrentStatus.Code)
			{
				// failed & unknown
				case(-1): 
				case(0): 
				case(7):
					Control_Start.Enabled = Control_Stop.Enabled = Control_Launch.Enabled = false;
					Control_Shutdown.Enabled = true;
					Control_Status.Text = Localizer.GetText(CurrentStatus.Code == -1 ? "Failed" : "Unknown");
					return;
				// waiting
				case(1):
					Control_Start.Enabled = Control_Shutdown.Enabled = true;
					Control_Stop.Enabled = Control_Launch.Enabled = false;

					Settings_GameLogin.Enabled = Settings_GamePassword.Enabled 
						= Settings_IsInternetServer.Enabled = true;
					
					break;
				// launching 
				case(2):
				case(3):
					Control_Stop.Enabled = true;
					Control_Start.Enabled = Control_Launch.Enabled = Control_Shutdown.Enabled = false;
					
					Settings_GameLogin.Enabled = Settings_GamePassword.Enabled 
						= Settings_IsInternetServer.Enabled = true;
					
					break;
				// running 
				case(4):
				case(5):
				case(6):
					Control_Stop.Enabled = true;
					Control_Start.Enabled = Control_Launch.Enabled = Control_Shutdown.Enabled = false;
					
					Settings_GameLogin.Enabled = Settings_GamePassword.Enabled 
						= Settings_IsInternetServer.Enabled = false;
					break;
			}
		}
        
		
#if false
private void Control_Timer(Object myObject, EventArgs myEventArgs)
		{
			/*	cas => actions autorises
			 *		- serveur non lanc => launch
			 *		- serveur lanc mais ne rpond pas ou rpond status unknown => rien 
			 *		- serveur lanc en attente console => start internet, start lan, shutdown
			 *		- serveur lanc en attente graphique => rien
			 *		- serveur lanc en cours de partie => stop, shutdown
			 */
			 
			/*if (!IsServerProcessLaunched)
				if (!CheckServerLaunched())
				{
					// server process not found
					Control_Start.Enabled = Control_Stop.Enabled = Control_Shutdown.Enabled = false;
					Control_Launch.Enabled = true;
					return;
				}*/

			if (!IsAuth)
				CheckAuthentification();
			
			CheckStatus();
		}
#endif

		private void Control_Shutdown_Click(object sender, System.EventArgs e)
		{
			try
			{
				bool Success = Proxy.QuitGame();
				Control_UpdateStatus(Success);
			}
			catch (Exception Ex)
			{
				Control_UpdateStatus(Ex.Message);
			}
		}

		private void Control_Start_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (Settings_IsInternetServer.Checked)
				{
					SStartServerParamInternet Param;
					Param.Login = Settings_GameLogin.Text;
					Param.Password = Settings_GamePassword.Text;
		
					bool Success = Proxy.StartServerInternet(Param);
					Control_UpdateStatus(Success);
				}
				else
				{
					bool Success = Proxy.StartServerLan();
					Control_UpdateStatus(Success);
				}
			}
			catch (Exception Ex)
			{
				Control_UpdateStatus(Ex.Message);
			}
		}

		private void Control_Stop_Click(object sender, System.EventArgs e)
		{
			try
			{
				bool Success = Proxy.StopServer();
				Control_UpdateStatus(Success);
			}
			catch (Exception Ex)
			{
				Control_UpdateStatus(Ex.Message);
			}
		}

		private void Control_UpdateStatus(string _Error)
		{
			Control_AppStatus.Text = Localizer.GetText("Error:") + _Error;
		}
		private void Control_UpdateStatus(bool _Success)
		{
			Control_AppStatus.Text = _Success ? Localizer.GetText("Done") : Localizer.GetText("Failed");
		}

		private void RefreshCurrentTab() 
		{
			if (!IsAuth)
				CheckAuthentification();
			CheckStatus();
			
			switch(ServerTab.SelectedIndex)
			{
				case(0):
					General_Refresh();
					break;
				case(1):
					GameInfo_Refresh();
					break;
				case(2):
					MapControl_Refresh();
					break;
				case(3):
					PlayerControl_Refresh();
					break;
				case(4):
					ServerStats_Refresh();
					break;
			}
		}

		private void Control_Refresh_Click(object sender, System.EventArgs e)
		{
			RefreshCurrentTab();
		}

		private void ServerTab_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			RefreshCurrentTab();			
		}

		private void Control_Load_Click(object sender, System.EventArgs e)
		{
/*			openFileDialog1.Title = Localizer.GetText("Choose your config file");
			openFileDialog1.Multiselect = false;
			DialogResult Res = openFileDialog1.ShowDialog(this);
			if (Res == DialogResult.OK)
			{
				string Filename = openFileDialog1.FileName;
				if (!File.Exists(Filename))
					return;
				else
				{
					StreamReader ConfigFile = File.OpenText(Filename);

					General_LoadConfig(ConfigFile);
					GameInfo_LoadConfig(ConfigFile);

					ConfigFile.Close();
				}
			}*/
		}

		private void Control_Save_Click(object sender, System.EventArgs e)
		{
/*			openFileDialog1.Title = Localizer.GetText("Choose your config file");
			openFileDialog1.Multiselect = false;
			DialogResult Res = openFileDialog1.ShowDialog(this);
			if (Res == DialogResult.OK)
			{
				string Filename = openFileDialog1.FileName;
				if (File.Exists(Filename))
					File.Delete(Filename);
                
				StreamWriter ConfigFile = File.AppendText(Filename);
				
				General_SaveConfig(ConfigFile);
				GameInfo_SaveConfig(ConfigFile);
				Settings_SaveConfig(ConfigFile);

				ConfigFile.Close();
			}		*/			
		}

	
		/*
		 * General
		 */


		private bool General_IsEditing = false;
		private bool General_IsRequesting = false;

		private void General_Initialize()
		{
			General_AllowP2PDownload.Enabled = false;
			General_AllowP2PUpload.Enabled = false;
			General_CurrentMaxPlayer.Enabled = false;
			General_CurrentMaxSpectator.Enabled = false;
			General_NextMaxPlayer.Enabled = false;
			General_NextMaxSpectator.Enabled = false;
			General_ServerComment.Enabled = false;
			General_ServerName.Enabled = false;
			General_PlayerPassword.Enabled = false;	
			General_SpectatorPassword.Enabled = false;	
		}

		private void General_Refresh()
		{
			if (General_IsRequesting)
				return;
			else
				General_IsRequesting = true;

			try
			{
				VoidDelegate Dele = new VoidDelegate(General_RefreshThread);
				Dele.BeginInvoke(null,null);
			}
			catch
			{
                General_IsRequesting = false;
			}
		}

		private void General_RefreshThread()
		{
			// les refreshs de chaque panel ont cette structure d'exception
			// afin de passer au moins un rsultat par dfaut si l'appel plante
			SServerOptions Options = new SServerOptions();
			try
			{
				Options = Proxy.GetServerOptions();
			}
			catch (Exception e)
			{
				Console.WriteLine(e.Message);
				Options.SetDefault();
			}
			finally 
			{
				object[] Arg = {Options};
				try 
				{
					tabPage1.BeginInvoke(new VoidDelegateServerOptions(General_Show), Arg);
				}
				catch (Exception e)
				{
					Console.WriteLine(e.Message);
					General_IsRequesting = false;
				}
			}
		}

		private void General_Show(SServerOptions _Option)
		{
			General_AllowP2PDownload.Checked = _Option.IsP2PDownload;
			General_AllowP2PUpload.Checked = _Option.IsP2PUpload;
			General_CurrentMaxPlayer.Text = _Option.CurrentMaxPlayers.ToString();
			General_CurrentMaxSpectator.Text = _Option.CurrentMaxSpectators.ToString();
			General_NextMaxPlayer.Text = _Option.NextMaxPlayers.ToString();
			General_NextMaxSpectator.Text = _Option.NextMaxSpectators.ToString();
			General_ServerComment.Text = _Option.Comment;
			General_ServerName.Text = _Option.Name;
			General_PlayerPassword.Text = _Option.Password;
			General_SpectatorPassword.Text = _Option.PasswordForSpectator;
			General_IsRequesting = false;
		}

		private void General_Apply()
		{
			if (General_IsRequesting)
				return;
			else
				General_IsRequesting = true;
			
			SServerOptions Options = new SServerOptions();
			try 
			{
				Options.Comment = General_ServerComment.Text;
				Options.IsP2PDownload = General_AllowP2PDownload.Checked;
				Options.IsP2PUpload = General_AllowP2PUpload.Checked;
				Options.CurrentMaxPlayers = int.Parse(General_CurrentMaxPlayer.Text);
				Options.NextMaxPlayers = int.Parse(General_NextMaxPlayer.Text);
				Options.NextMaxSpectators = int.Parse(General_NextMaxSpectator.Text);
				Options.Name = General_ServerName.Text;
				Options.Password = General_PlayerPassword.Text;
				Options.PasswordForSpectator = General_SpectatorPassword.Text;
			}
			catch
			{
				Options.SetDefault();
			}

			General_AllowP2PDownload.Enabled = false;
			General_AllowP2PUpload.Enabled = false;
			General_CurrentMaxPlayer.Enabled = false;
			General_NextMaxPlayer.Enabled = false;
			General_CurrentMaxSpectator.Enabled = false;
			General_NextMaxSpectator.Enabled = false;
			General_ServerComment.Enabled = false;
			General_ServerName.Enabled = false;
			General_PlayerPassword.Enabled = false;
			General_SpectatorPassword.Enabled = false;
			General_Edit.Text = Localizer.GetText("Edit");

			try
			{
				VoidDelegateServerOptions Dele = new VoidDelegateServerOptions(General_ApplyThread);
				Dele.BeginInvoke(Options, null, null);
			}
			catch
			{
				General_IsRequesting = false;
			}
		}

		private void General_ApplyThread(SServerOptions _Options)
		{	
			try 
			{
				Proxy.SetServerOptions(_Options);
				ServerTab.BeginInvoke(new VoidDelegate(General_Refresh));
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				General_IsRequesting = false;
			}
		}
		
		private void General_Edit_Click(object sender, System.EventArgs e)
		{
			if (!General_IsEditing)
			{
				General_AllowP2PDownload.Enabled = true;
				General_AllowP2PUpload.Enabled = true;
				General_CurrentMaxPlayer.Enabled = false;
				General_NextMaxPlayer.Enabled = true;
				General_NextMaxSpectator.Enabled = true;
				General_CurrentMaxSpectator.Enabled = false;
				General_ServerComment.Enabled = true;
				General_ServerName.Enabled = true;
				General_PlayerPassword.Enabled = true;
				General_SpectatorPassword.Enabled = true;

				General_IsEditing = true;
				General_Edit.Text = Localizer.GetText("Apply");
			}
			else
			{
				General_IsEditing = false;
				General_Edit.Text = Localizer.GetText("Edit");
				General_Apply();
			}
			
		}
	
		/*
		 * GameInfo Refresh
		 */

		private bool GameInfo_IsEditing = false;
		private bool GameInfo_IsRequesting = false;

		private void GameInfo_Initialize()
		{
			GameInfo_Current_ChatTime.Enabled = false;
			GameInfo_Current_GameMode.Enabled = false;
			GameInfo_Current_LapsNbLaps.Enabled = false;
			GameInfo_Current_LapsTimeLimit.Enabled = false;
			GameInfo_Current_NbChallenge.Enabled = false;
			GameInfo_Current_RoundPointsLimit.Enabled = false;
			GameInfo_Current_RoundUseNewRules.Enabled = false;
			GameInfo_Current_TeamMaxPoints.Enabled = false;
			GameInfo_Current_TeamPointsLimit.Enabled = false;
			GameInfo_Current_TeamUseNewRules.Enabled = false;
			GameInfo_Current_TimeAttackLimit.Enabled = false;
			
			GameInfo_Next_ChatTime.Enabled = false;
			GameInfo_Next_GameMode.Enabled = false;
			GameInfo_Next_LapsNbLaps.Enabled = false;
			GameInfo_Next_LapsTimeLimit.Enabled = false;
			GameInfo_Next_NbChallenge.Enabled = false;
			GameInfo_Next_RoundPointsLimit.Enabled = false;
			GameInfo_Next_RoundUseNewRules.Enabled = false;
			GameInfo_Next_TeamMaxPoints.Enabled = false;
			GameInfo_Next_TeamPointsLimit.Enabled = false;
			GameInfo_Next_TeamUseNewRules.Enabled = false;
			GameInfo_Next_TimeAttackLimit.Enabled = false;
		}

		private void GameInfo_Refresh()
		{
			if (GameInfo_IsRequesting)
				return;
			else
				GameInfo_IsRequesting = true;

			try
			{
				VoidDelegate Dele = new VoidDelegate(GameInfo_RefreshThread);
				Dele.BeginInvoke(null, null);
			}
			catch
			{
				GameInfo_IsRequesting = false;
			}
		}

		private void GameInfo_RefreshThread()
		{
			SFullGameInfo Infos = new SFullGameInfo();
			try
			{
				Infos = Proxy.GetGameInfos();
			}
			catch
			{
				Infos.SetDefault();
			}
			finally 
			{
				try
				{
					object[] Arg = {Infos};
					ServerTab.BeginInvoke(new VoidDelegateFullGameInfo(GameInfo_Show), Arg);
				}
				catch(Exception e)
				{
					Console.WriteLine(e.Message);
				}
				finally
				{
					GameInfo_IsRequesting = false;
				}
			}
		}

		private void GameInfo_Show(SFullGameInfo _Infos)
		{
			GameInfo_Current_ChatTime.Text = _Infos.CurrentGameInfos.ChatTime.ToString();
			GameInfo_Current_GameMode.SelectedIndex = _Infos.CurrentGameInfos.GameMode;
			GameInfo_Current_LapsNbLaps.Text = _Infos.CurrentGameInfos.LapsNbLaps.ToString();
			GameInfo_Current_LapsTimeLimit.Text = _Infos.CurrentGameInfos.LapsTimeLimit.ToString();
			GameInfo_Current_NbChallenge.Text = _Infos.CurrentGameInfos.NbChallenge.ToString();
			GameInfo_Current_RoundPointsLimit.Text = _Infos.CurrentGameInfos.RoundsPointsLimit.ToString();
			GameInfo_Current_RoundUseNewRules.Checked = _Infos.CurrentGameInfos.RoundsUseNewRules;
			GameInfo_Current_TeamMaxPoints.Text = _Infos.CurrentGameInfos.TeamMaxPoints.ToString();
			GameInfo_Current_TeamPointsLimit.Text = _Infos.CurrentGameInfos.TeamPointsLimit.ToString();
			GameInfo_Current_TeamUseNewRules.Checked = _Infos.CurrentGameInfos.TeamUseNewRules;
			GameInfo_Current_TimeAttackLimit.Text = _Infos.CurrentGameInfos.TimeAttackLimit.ToString();

			GameInfo_Next_ChatTime.Text = _Infos.NextGameInfos.ChatTime.ToString();
			GameInfo_Next_GameMode.SelectedIndex = _Infos.NextGameInfos.GameMode;
			GameInfo_Next_LapsNbLaps.Text = _Infos.NextGameInfos.LapsNbLaps.ToString();
			GameInfo_Next_LapsTimeLimit.Text = _Infos.NextGameInfos.LapsTimeLimit.ToString();
			GameInfo_Next_NbChallenge.Text = _Infos.NextGameInfos.NbChallenge.ToString();
			GameInfo_Next_RoundPointsLimit.Text = _Infos.NextGameInfos.RoundsPointsLimit.ToString();
			GameInfo_Next_RoundUseNewRules.Checked = _Infos.NextGameInfos.RoundsUseNewRules;
			GameInfo_Next_TeamMaxPoints.Text = _Infos.NextGameInfos.TeamMaxPoints.ToString();
			GameInfo_Next_TeamPointsLimit.Text = _Infos.NextGameInfos.TeamPointsLimit.ToString();
			GameInfo_Next_TeamUseNewRules.Checked = _Infos.NextGameInfos.TeamUseNewRules;
			GameInfo_Next_TimeAttackLimit.Text = _Infos.NextGameInfos.TimeAttackLimit.ToString();
		}

		private void GameInfo_Apply()
		{
			if (GameInfo_IsRequesting)
				return;
			else
				GameInfo_IsRequesting = true;

			SGameInfo Info = new SGameInfo();
			Info.SetDefault();

			Info.ChatTime = int.Parse(GameInfo_Next_ChatTime.Text);
			Info.GameMode = GameInfo_Next_GameMode.FindString(GameInfo_Next_GameMode.Text);
			if (Info.GameMode == -1) 
			{
				Info.GameMode = GameInfo_Next_GameMode.FindString(GameInfo_Current_GameMode.Text);				
			}
			Info.LapsNbLaps = int.Parse(GameInfo_Next_LapsNbLaps.Text);
			Info.LapsTimeLimit = int.Parse(GameInfo_Next_LapsTimeLimit.Text);
			Info.NbChallenge = int.Parse(GameInfo_Next_NbChallenge.Text);
			Info.RoundsPointsLimit = int.Parse(GameInfo_Next_RoundPointsLimit.Text);
			Info.RoundsUseNewRules = GameInfo_Next_RoundUseNewRules.Checked;
			Info.TeamMaxPoints = int.Parse(GameInfo_Next_TeamMaxPoints.Text);
			Info.TeamPointsLimit = int.Parse(GameInfo_Next_TeamPointsLimit.Text);
			Info.TeamUseNewRules = GameInfo_Next_TeamUseNewRules.Checked;
			Info.TimeAttackLimit = int.Parse(GameInfo_Next_TimeAttackLimit.Text);

			GameInfo_Next_ChatTime.Enabled = false;
			GameInfo_Next_GameMode.Enabled = false;
			GameInfo_Next_LapsNbLaps.Enabled = false;
			GameInfo_Next_LapsTimeLimit.Enabled = false;
			GameInfo_Next_NbChallenge.Enabled = false;
			GameInfo_Next_RoundPointsLimit.Enabled = false;
			GameInfo_Next_RoundUseNewRules.Enabled = false;
			GameInfo_Next_TeamMaxPoints.Enabled = false;
			GameInfo_Next_TeamPointsLimit.Enabled = false;
			GameInfo_Next_TeamUseNewRules.Enabled = false;
			GameInfo_Next_TimeAttackLimit.Enabled = false;

			try
			{
				VoidDelegateGameInfo Dele = new VoidDelegateGameInfo(GameInfo_ApplyThread);
				Dele.BeginInvoke(Info, null, null);
			}
			catch
			{
				GameInfo_IsRequesting = false;
			}
		}
		
		private void GameInfo_ApplyThread(SGameInfo _Infos)
		{
			try
			{	
				Proxy.SetGameInfos(_Infos);
				ServerTab.BeginInvoke(new VoidDelegate(GameInfo_Refresh));
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				GameInfo_IsRequesting = false;
			}
		}
		
		private void GameInfo_Edit_Click(object sender, System.EventArgs e)
		{
			if(!GameInfo_IsEditing)
			{
				GameInfo_Next_ChatTime.Enabled = true;
				GameInfo_Next_GameMode.Enabled = true;
				GameInfo_Next_LapsNbLaps.Enabled = true;
				GameInfo_Next_LapsTimeLimit.Enabled = true;
				GameInfo_Next_NbChallenge.Enabled = false;
				GameInfo_Next_RoundPointsLimit.Enabled = true;
				GameInfo_Next_RoundUseNewRules.Enabled = true;
				GameInfo_Next_TeamMaxPoints.Enabled = true;
				GameInfo_Next_TeamPointsLimit.Enabled = true;
				GameInfo_Next_TeamUseNewRules.Enabled = true;
				GameInfo_Next_TimeAttackLimit.Enabled = true;
				
				GameInfo_IsEditing = true;
				GameInfo_Edit.Text = Localizer.GetText("Apply");
			}
			else
			{
				GameInfo_IsEditing = false;
				GameInfo_Edit.Text = Localizer.GetText("Edit");
				GameInfo_Apply();
			}
		}
	
		/*
		 * Map Control
		 */

		private SChallengeQuickInfo[] ChallengeInfos = null;
		private bool MapControl_IsRequesting = false;

		private void MapControl_Initialize()
		{
			MapControl_ChallengeName.Text = "";
			MapControl_Mood.Text = "";
			MapControl_Filename.Text = "";
			MapControl_GoldTime.Text = "";
			MapControl_Environment.Text = "";
			MapControl_EditCurrentChallenge.Text = "";

			MapControl_ExportPlaylist.Enabled = true;
			MapControl_InsertPlaylist.Enabled = true;
			MapControl_ImportPlaylist.Enabled = true;
			MapControl_AddPlaylist.Enabled = true;
			MapControl_EditPlaylistName.Enabled = false;
			MapControl_PlaylistOK.Enabled = false;
		}

		private void MapControl_Refresh()
		{
			if (MapControl_IsRequesting)
				return;
			else
				MapControl_IsRequesting = true;
			
			try
			{
				VoidDelegate Dele = new VoidDelegate(MapControl_RefreshThread);
				Dele.BeginInvoke(null, null);	            
			}
			catch
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_RefreshThread()
		{

			SChallengeQuickInfo[] ChallengeInfos = new SChallengeQuickInfo[0];
			SChallengeInfo CurChallengeInfo = new SChallengeInfo();
			try
			{
				ChallengeInfos = Proxy.GetChallengeList(100,0);
				CurChallengeInfo = Proxy.GetCurrentChallengeInfo();
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				try 
				{
					object[] Arg = {ChallengeInfos, CurChallengeInfo};
					ServerTab.BeginInvoke(new VoidDelegateChallengeArray(MapControl_Show), Arg);
				}
				catch(Exception e)
				{	
					Console.WriteLine(e.Message);
				}
				finally
				{
					MapControl_IsRequesting = false;
				}
			}
		}

		private void MapControl_Show(SChallengeQuickInfo[] _InfosArray, SChallengeInfo _CurChallengeInfo)
		{
			MapControl_Browser.Items.Clear();
			ChallengeInfos = _InfosArray;
			foreach(SChallengeQuickInfo Info in ChallengeInfos)
			{
				MapControl_Browser.Items.Add(string.Format("{0}",Info.Name));
			}

			MapControl_EditCurrentChallenge.Text = _CurChallengeInfo.Name;
		}

		private void MapControl_ShowChallenge(SChallengeQuickInfo _Info)
		{
			MapControl_ChallengeName.Text = _Info.Name;
			MapControl_Mood.Text = _Info.Mood;
			MapControl_Filename.Text = _Info.FileName;
			MapControl_GoldTime.Text = _Info.GoldTime.ToString();
			MapControl_Environment.Text = _Info.Environnement;
		}

		private void MapControl_Browser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (MapControl_Browser.SelectedIndices.Count == 0)
				return;
			else
				MapControl_ShowChallenge(ChallengeInfos[MapControl_Browser.SelectedIndices[0]]);
		}

		private void MapControl_Restart_Click(object sender, System.EventArgs e)
		{
			if (MapControl_IsRequesting)
				return;
			else
				MapControl_IsRequesting = true;
			
			try
			{
				VoidDelegate Dele = new VoidDelegate(MapControl_RestartThread);
				Dele.BeginInvoke(null, null);
			}
			catch
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_RestartThread()
		{
			try 
			{
				bool Success = Proxy.ChallengeRestart();
				object[] Arg = {Success};
				ServerTab.BeginInvoke(new VoidDelegateBool(Control_UpdateStatus), Arg);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_NextMap_Click(object sender, System.EventArgs e)
		{
			if (MapControl_IsRequesting)
				return;
			else
				MapControl_IsRequesting = true;

			try
			{
				VoidDelegate Dele = new VoidDelegate(MapControl_NextMapThread);
				Dele.BeginInvoke(null, null);
			}
			catch
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_NextMapThread()
		{
			try
			{
				bool Success = Proxy.NextChallenge();
				MapControl_IsRequesting = false;
				object[] Arg = {Success};
				ServerTab.BeginInvoke(new VoidDelegateBool(Control_UpdateStatus), Arg);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_Add_Click(object sender, System.EventArgs e)
		{
			if (MapControl_IsRequesting)
				return;
			else
				MapControl_IsRequesting = true;

			try
			{
				VoidDelegateString Dele = new VoidDelegateString(MapControl_AddThread);
				Dele.BeginInvoke(MapControl_EditFilename.Text, null, null);
			}
			catch
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_AddThread(string _Filename)
		{
			try 
			{
				bool Success = Proxy.AddChallenge(_Filename);
				MapControl_IsRequesting = false;
				ServerTab.BeginInvoke(new VoidDelegate(MapControl_Refresh));
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_Remove_Click(object sender, System.EventArgs e)
		{
			if (MapControl_IsRequesting)
				return;
			else
				MapControl_IsRequesting = true;

			string[] Filenames = new string[MapControl_Browser.SelectedItems.Count];
			int FilenameIndex = 0;
			foreach(int Index in MapControl_Browser.SelectedIndices)
			{
				Filenames[FilenameIndex] = ChallengeInfos[Index].FileName;
				FilenameIndex++;
			}
			
			try
			{
				VoidDelegateStringArray Dele = new VoidDelegateStringArray(MapControl_RemoveThread);
				Dele.BeginInvoke(Filenames, null, null);
			}
			catch
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_RemoveThread(string[] _Filenames)
		{
			try
			{
				bool Success = Proxy.RemoveChallengeList(_Filenames) > 0;
				MapControl_IsRequesting = false;
				VoidDelegate Dele = new VoidDelegate(MapControl_Refresh);
				ServerTab.BeginInvoke(Dele);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_BrowseChallenge_Click(object send, System.EventArgs e)
		{
			if (MapControl_IsRequesting)
				return;
			else
				MapControl_IsRequesting = true;

			openFileDialog1.Title = Localizer.GetText("Choose a Challenge(s)");
			openFileDialog1.Multiselect = true;
			DialogResult Res = openFileDialog1.ShowDialog(this);
			if (Res == DialogResult.OK)
			{
				try
				{
					VoidDelegateStringArray Dele = new VoidDelegateStringArray(MapControl_BrowseChallengeThread);
					Dele.BeginInvoke(openFileDialog1.FileNames, null, null);
				}
				catch
				{
					MapControl_IsRequesting = false;
				}
			}
			else
				MapControl_IsRequesting = false;
		}

		private void MapControl_BrowseChallengeThread(string[] _Filename)
		{
			try 
			{
				bool Success = false;
				if (_Filename.Length == 0)
					return;
				else
					if (_Filename.Length == 1)
					Success = Proxy.AddChallenge(_Filename[0]);
				else
					Success = Proxy.AddChallengeList(_Filename) > 0;
				MapControl_IsRequesting = false;
				VoidDelegate Dele = new VoidDelegate(MapControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);

			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				MapControl_IsRequesting = false;
			}
		}
		
		private void MapControl_ImportPlaylist_Click(object sender, System.EventArgs e)
		{
			MapControl_EditPlaylistName.Enabled = true;		
			MapControl_PlaylistOK.Enabled = true;

			MapControl_AddPlaylist.Enabled = false;
			MapControl_ExportPlaylist.Enabled = false;
			MapControl_InsertPlaylist.Enabled = false;
		}

		private void MapControl_AddPlaylist_Click(object sender, System.EventArgs e)
		{
			MapControl_EditPlaylistName.Enabled = true;		
			MapControl_PlaylistOK.Enabled = true;	
	
			MapControl_ImportPlaylist.Enabled = false;
			MapControl_ExportPlaylist.Enabled = false;
			MapControl_InsertPlaylist.Enabled = false;
		}

		private void MapControl_ExportPlaylist_Click(object sender, System.EventArgs e)
		{
			MapControl_EditPlaylistName.Enabled = true;		
			MapControl_PlaylistOK.Enabled = true;	

			MapControl_InsertPlaylist.Enabled = false;
			MapControl_AddPlaylist.Enabled = false;
			MapControl_ImportPlaylist.Enabled = false;
		}

		private void MapControl_InsertPlaylist_Click(object sender, System.EventArgs e)
		{
			MapControl_EditPlaylistName.Enabled = true;		
			MapControl_PlaylistOK.Enabled = true;

			MapControl_AddPlaylist.Enabled = false;
			MapControl_ImportPlaylist.Enabled = false;
			MapControl_ExportPlaylist.Enabled = false;
		}

		private void MapControl_PlaylistOK_Click(object sender, System.EventArgs e)
		{
			int choice;
			if (MapControl_ImportPlaylist.Enabled)
			{
				choice = 0;
				MapControl_ExportPlaylist.Enabled = true;
				MapControl_InsertPlaylist.Enabled = true;
				MapControl_AddPlaylist.Enabled = true;
			}
			else if (MapControl_ExportPlaylist.Enabled)
			{
				choice = 1;
				MapControl_ImportPlaylist.Enabled = true;
				MapControl_InsertPlaylist.Enabled = true;
				MapControl_AddPlaylist.Enabled = true;
			}
			else if (MapControl_InsertPlaylist.Enabled)
			{
				choice = 2;
				MapControl_ImportPlaylist.Enabled = true;
				MapControl_ExportPlaylist.Enabled = true;
				MapControl_AddPlaylist.Enabled = true;
			}
			else
			{
				choice = 3;
				MapControl_ImportPlaylist.Enabled = true;
				MapControl_ExportPlaylist.Enabled = true;
				MapControl_InsertPlaylist.Enabled = true;
			}

			MapControl_EditPlaylistName.Enabled = false;		
			MapControl_PlaylistOK.Enabled = false;

			try 
			{
				VoidDelegateStringInt Dele = new VoidDelegateStringInt(MapControl_PlayerlistThread);
				Dele.BeginInvoke(MapControl_EditPlaylistName.Text, choice, null, null);
			}
			catch
			{
				MapControl_IsRequesting = false;
			}
		}

		private void MapControl_PlayerlistThread(string _filename, int choice)
		{
			try 
			{
				bool Success = false;
				switch(choice)
				{
					case(0):
						Success = Proxy.LoadMatchSettings(_filename) > 0;
						break;
					case(1):
						Success = Proxy.SaveMatchSettings(_filename) > 0;
						break;
					case(2):
						Success = Proxy.InsertPlaylistFromMatchSettings(_filename) > 0;
						break;
					case(3):
						Success = Proxy.AppendPlaylistFromMatchSettings(_filename) > 0;
						break;
				}

				VoidDelegate Dele = new VoidDelegate(MapControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				MapControl_IsRequesting = false;
			}
		}


		/*
		 * Player Control
		 */

		private SPlayerQuickInfo[] PlayerInfos = null;
		private SPlayerInfoBanned[] PlayerInfosBanned = null;
		private SPlayerInfoBlack[] PlayerInfosBlack = null;

		private bool PlayerInfo_IsRequesting = false;
        
		private void PlayerControl_Initialize()
		{
			PlayerControl_Login.Text = "";
			PlayerControl_Nickname.Text = "";
			PlayerControl_Ranking.Text = "";
			PlayerControl_Id.Text = "";
		}
		
		private void PlayerControl_Refresh()
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			try
			{
				VoidDelegate Dele = new VoidDelegate(PlayerControl_RefreshThread);
				Dele.BeginInvoke(null, null);
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_RefreshThread()
		{
			SPlayerQuickInfo[] PlayerInfoArray = new SPlayerQuickInfo[0];
			SPlayerInfoBanned[] PlayerInfoBannedArray = new SPlayerInfoBanned[0];
			SPlayerInfoBlack[] PlayerInfoBlackArray = new SPlayerInfoBlack[0];
			try
			{
				PlayerInfoArray = Proxy.GetPlayerList(100,0);
				PlayerInfoBannedArray = Proxy.GetBanList(100,0);
				PlayerInfoBlackArray = Proxy.GetBlackList(100,0);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				try
				{
					object[] Arg = {PlayerInfoArray, PlayerInfoBannedArray, PlayerInfoBlackArray};
					ServerTab.BeginInvoke(new VoidDelegateMegaPlayerInfo(PlayerControl_GeneralShow),Arg);
				}
				catch(Exception e)
				{
					Console.WriteLine(e.Message);
				}
				finally
				{
					PlayerInfo_IsRequesting = false;
				}
			}
		}

		private void PlayerControl_GeneralShow(SPlayerQuickInfo[] PlayerInfoArray,
			SPlayerInfoBanned[] PlayerInfoBannedArray, SPlayerInfoBlack[] PlayerInfoBlackArray)
		{
			PlayerInfos = PlayerInfoArray;
			PlayerInfosBanned = PlayerInfoBannedArray;
			PlayerInfosBlack = PlayerInfoBlackArray;

			PlayerControl_Show(PlayerInfoArray);
			PlayerControl_ShowBanned(PlayerInfoBannedArray);
			PlayerControl_ShowBlack(PlayerInfoBlackArray);
		}

		private void PlayerControl_Show(SPlayerQuickInfo[] _InfosArray)
		{
			PlayerControl_PlayerBrowser.Items.Clear();
			foreach(SPlayerQuickInfo Info in _InfosArray)
			{
				PlayerControl_PlayerBrowser.Items.Add(string.Format("{0}",Info.NickName));
			}
		}
 
		private void PlayerControl_ShowBanned(SPlayerInfoBanned[] _InfosArray)
		{
			PlayerControl_BanBrowser.Items.Clear();
			foreach(SPlayerInfoBanned Info in PlayerInfosBanned)
			{
				PlayerControl_BanBrowser.Items.Add(string.Format("{0}",Info.Login));
			}
		}
		private void PlayerControl_ShowBlack(SPlayerInfoBlack[] _Info)
		{
			PlayerControl_BlackBrowser.Items.Clear();
			foreach(SPlayerInfoBlack Info in PlayerInfosBlack)
			{
				PlayerControl_BlackBrowser.Items.Add(string.Format("{0}",Info.Login));
			}
		}
		private void PlayerControl_ShowChallenge(SPlayerQuickInfo Info)
		{
			PlayerControl_Login.Text = Info.Login;
			PlayerControl_Nickname.Text = Info.NickName;
			PlayerControl_Ranking.Text = Info.LadderRanking.ToString();
			PlayerControl_Id.Text = "..."; //Info.Id.ToString();
		}

		private void PlayerControl_PlayerBrowser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (PlayerControl_PlayerBrowser.SelectedIndices.Count == 0)
				return;
			else
				PlayerControl_ShowChallenge(PlayerInfos[PlayerControl_PlayerBrowser.SelectedIndices[0]]);
		}

		private void PlayerControl_Ban_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			int PlayernameIndex = 0;
			string[] PlayerNames = new string[PlayerControl_PlayerBrowser.SelectedIndices.Count]; 
			foreach(int Index in PlayerControl_PlayerBrowser.SelectedIndices)
			{
				PlayerNames[PlayernameIndex] = PlayerInfos[Index].Login;
				PlayernameIndex++;
			}

			try 
			{
				VoidDelegateStringArray Dele = new VoidDelegateStringArray(PlayerControl_BanThread);
				Dele.BeginInvoke(PlayerNames, null, null); 
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_BanThread(string[] PlayerNames)
		{
			try 
			{
				PlayerInfo_IsRequesting = false;
				foreach(string Name in PlayerNames)
				{
					Proxy.Ban(Name);
				}
				PlayerInfo_IsRequesting = false;
				VoidDelegate Dele = new VoidDelegate(PlayerControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}

		private void PlayerControl_Kick_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			int PlayernameIndex = 0;
			string[] PlayerNames = new string[PlayerControl_PlayerBrowser.SelectedIndices.Count]; 
			foreach(int Index in PlayerControl_PlayerBrowser.SelectedIndices)
			{
				PlayerNames[PlayernameIndex] = PlayerInfos[Index].Login;
				PlayernameIndex++;
			}

			try
			{
				VoidDelegateStringArray Dele = new VoidDelegateStringArray(PlayerControl_KickThread);
				Dele.BeginInvoke(PlayerNames, null, null); 
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_KickThread(string[] PlayerNames)
		{
			try 
			{
				PlayerInfo_IsRequesting = false;
				foreach(string Name in PlayerNames)
				{
					Proxy.Kick(Name);
				}
				VoidDelegate Dele = new VoidDelegate(PlayerControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}

		private void PlayerControl_Black_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;
			
			int PlayernameIndex = 0;
			string[] PlayerNames = new string[PlayerControl_PlayerBrowser.SelectedIndices.Count]; 
			foreach(int Index in PlayerControl_PlayerBrowser.SelectedIndices)
			{
				PlayerNames[PlayernameIndex] = PlayerInfos[Index].Login;
				PlayernameIndex++;
			}
			
			try
			{
				VoidDelegateStringArray Dele = new VoidDelegateStringArray(PlayerControl_BlackThread);
				Dele.BeginInvoke(PlayerNames, null, null); 
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_BlackThread(string[] PlayerNames)
		{
			try 
			{
				PlayerInfo_IsRequesting = false;
				foreach(string Name in PlayerNames)
				{
					Proxy.BlackList(Name);
				}
				VoidDelegate Dele = new VoidDelegate(PlayerControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}

		private void PlayerControl_ClearBan_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			try
			{
				VoidDelegate Dele = new VoidDelegate(PlayerControl_CleanBanThread);
				Dele.BeginInvoke(null, null);
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_CleanBanThread()
		{
			try
			{
				PlayerInfo_IsRequesting = false;
				bool Success = Proxy.CleanBanList();
				object[] Arg = {Success};
				ServerTab.BeginInvoke(new VoidDelegate(PlayerControl_Refresh),Arg);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}

		private void PlayerControl_CleanBlack_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			try
			{
				VoidDelegate Dele = new VoidDelegate(PlayerControl_CleanBlackThread);
				Dele.BeginInvoke(null, null);				
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_CleanBlackThread()
		{
			try
			{
				PlayerInfo_IsRequesting = false;
				bool Success = Proxy.CleanBlackList();
				object[] Arg = {Success};
				ServerTab.BeginInvoke(new VoidDelegate(PlayerControl_Refresh),Arg);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}

		private void PlayerControl_Unban_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			try
			{
				string[] LoginsBanned = new string[PlayerControl_BanBrowser.SelectedIndices.Count];
				int loginindex = 0;
				foreach(int Index in PlayerControl_BanBrowser.SelectedIndices)
				{
					LoginsBanned[loginindex] = PlayerInfosBanned[Index].Login;
				}
				VoidDelegateStringArray Dele = new VoidDelegateStringArray(PlayerControl_UnbanThread);
				Dele.BeginInvoke(LoginsBanned, null, null);
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}

		private void PlayerControl_UnbanThread(string[] Logins)
		{
			try
			{
				bool Success = true;
				if (Logins.Length == 0)
					Success = false;
				foreach(string Login in Logins)
					Success &= Proxy.UnBan(Login);
				PlayerInfo_IsRequesting = false;
				VoidDelegate Dele = new VoidDelegate(PlayerControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}

		private void PlayerControl_Unblack_Click(object sender, System.EventArgs e)
		{
			if (PlayerInfo_IsRequesting)
				return;
			else
				PlayerInfo_IsRequesting = true;

			try
			{
				string[] LoginsBlacked = new string[PlayerControl_BlackBrowser.SelectedIndices.Count];
				int loginindex = 0;
				foreach(int Index in PlayerControl_BlackBrowser.SelectedIndices)
				{
					LoginsBlacked[loginindex] = PlayerInfosBlack[Index].Login;
				}
				VoidDelegateStringArray Dele = new VoidDelegateStringArray(PlayerControl_UnblackThread);
				Dele.BeginInvoke(LoginsBlacked, null, null);
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}	

		private void PlayerControl_UnblackThread(string[] Logins)
		{
			try
			{
				bool Success = true;
				if (Logins.Length == 0)
					Success = false;
				foreach(string Login in Logins)
					Success &= Proxy.UnBlackList(Login);
				PlayerInfo_IsRequesting = false;
				VoidDelegate Dele = new VoidDelegate(PlayerControl_Refresh);
				ServerTab.BeginInvoke(Dele, null);
			}
			catch
			{
				PlayerInfo_IsRequesting = false;
			}
		}
		

		/*
		 *  Server Stats
		 */

		private SPlayerNetworkInfo[] PlayerStatsInfos;
		private bool ServerStats_IsRequesting = false;

		private void ServerStats_Refresh()
		{
			if (ServerStats_IsRequesting)
				return;
			else
				ServerStats_IsRequesting = true;

			try 
			{
				VoidDelegate Dele = new VoidDelegate(ServerStats_RefreshThread);
				Dele.BeginInvoke(null, null);
			}
			catch
			{
				ServerStats_IsRequesting = false;
			}
		}

		private void ServerStats_RefreshThread()
		{
			SNetworkStats Stats = new SNetworkStats();
			try 
			{
				Stats = Proxy.GetNetworkStats();
			}
			catch
			{	
				Stats.MeanConnectionTime = Stats.MeanNbrPlayer = Stats.NbrConnection =
					Stats.RecvNetRate = Stats.SendNetRate = Stats.TotalReceivingSize =
					Stats.TotalSendingSize = Stats.Uptime = 0;
				Stats.PlayerNetInfos = new SPlayerNetworkInfo[0];
			}
			finally
			{
				try
				{
					object[] Arg = {Stats};
					VoidDelegateNetworkStats Dele = new VoidDelegateNetworkStats(ServerStats_Show);
					ServerTab.BeginInvoke(Dele,Arg);
				}
				catch(Exception e)
				{
					ServerStats_IsRequesting = false;
					Console.WriteLine(e.Message);
				}
			}
		}

		private void ServerStats_Show(SNetworkStats _Infos)
		{
			SNetworkStats Stats = _Infos;
			PlayerStatsInfos = Stats.PlayerNetInfos;

			ServerStats_Uptime.Text = Stats.Uptime.ToString();
			ServerStats_NbConnections.Text = Stats.NbrConnection.ToString();
			ServerStats_MeanConnectionTime.Text = Stats.MeanConnectionTime.ToString();
			ServerStats_MeanNbPlayer.Text = Stats.MeanNbrPlayer.ToString();
			ServerStats_RecNetRate.Text = Stats.RecvNetRate.ToString();
			ServerStats_SendNetRate.Text = Stats.SendNetRate.ToString();
			ServerStats_TotalReceivingSize.Text = Stats.TotalReceivingSize.ToString();
			ServerStats_TotalSendingSize.Text = Stats.TotalSendingSize.ToString();

			ServerStats_Browser.Clear();
			foreach(SPlayerNetworkInfo Info in PlayerStatsInfos)
			{
				ServerStats_Browser.Items.Add(string.Format("{0}",Info.Login));
			}

			ServerStats_IsRequesting = false;
		}

		private void ServerStats_ShowPlayerStats(SPlayerNetworkInfo _Info)
		{
			ServerStats_Login.Text = _Info.Login;
			ServerStats_IPAddress.Text = _Info.IPAddress;
			ServerStats_LastTransfertTime.Text = _Info.LastTransferTime.ToString();
			ServerStats_Delta.Text = _Info.DeltaBetweenTwoLastNetState.ToString();
			ServerStats_PacketLoss.Text = _Info.PacketLossRate.ToString();
		}

		private void ServerStats_Browser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (ServerStats_Browser.SelectedIndices.Count == 0)
				return;
			else
				ServerStats_ShowPlayerStats(PlayerStatsInfos[ServerStats_Browser.SelectedIndices[0]]);
		}


		/*
		 * Settings
		 */
		
		private bool Settings_IsEditing = false;

		private void Settings_Edit_Click(object sender, System.EventArgs e)
		{
			if (Settings_IsEditing)
			{
				Settings_Edit.Text = Localizer.GetText("Apply");
				Settings_Login.Enabled = Settings_Password.Enabled = true;
			}
			else
			{
				IsAuth = false;
				Settings_Edit.Text = Localizer.GetText("Edit");
				Settings_Login.Enabled = Settings_Password.Enabled = false;
			}
		}
		

		private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			
		}
	}
}
